;XIncludeFile "RMChart.pbi"
;RMC_Init()

#GridX=10
#GridY=10
#GridW=600
#GridH=450

Enumeration 1 ; Windows
  #Window_Main
  #Window_MiniDesigner
EndEnumeration

Enumeration #WM_USER+1024 ; Charts
  #ID_RMC1
  #ID_RMC2
  #ID_RMC3
EndEnumeration

Enumeration 1 ; Gadgets
  #ID_EXPORT
  #ID_PRINT
  #ID_CLOSE
  #ID_SCROLL
  #IDC_GRAPHIC1
  #ID_CB_COLOR
  #ID_CB_COLOROBJ
  #ID_OPT_H
  #ID_OPT_V
  #ID_OPT_FH
  #ID_OPT_SH
  #ID_CB_S1STYLE
  #ID_CB_S2STYLE
  #ID_CHK_S1HIDE
  #ID_CHK_S2HIDE
  #ID_CHK_S1VLABEL
  #ID_CHK_S2VLABEL
  #ID_CHK_LUCENT
  #ID_CB_LSTYLE
  #ID_CB_SYMBOLS
  #ID_LBL_LSTYLE
  #ID_LBL_SYMBOLS
  #ID_CHK_CLONE
  #ID_OPT_JPG
  #ID_OPT_EMF
  #ID_CMD_PRINT
  #ID_CMD_SAVE
  #ID_CMD_COPY
  #ID_MD_CLOSE
  #ID_INFO
  #ID_CHK_TOOLTIPS
EndEnumeration

Enumeration 1 ; Menus
  #Menu_Main
  #Menu_MiniDesigner
EndEnumeration

Enumeration 1 ; Menu-items
  #ID_GB1
  #ID_GB2
  #ID_GB3
  #ID_GB4
  #ID_GB5
  #ID_GB6
  #ID_GB7
  #ID_GB8
  #ID_GB9
  #ID_GB10
  #ID_NGB1
  #ID_NGB2
  #ID_XY1
  #ID_XY2
  #ID_MSC1
  #ID_MSC2
  #ID_MSC3
  #ID_MSC4
  #ID_MSC5
  #ID_MSC6
  #ID_MSC7
  #ID_MSC8
  #ID_MSC9
  #ID_MSC10
EndEnumeration

Global siH.SCROLLINFO
Global lScrH.l
Global nChangeData.l         ; for RMC_SetData() demonstration in the first line chart
Global nShowClone.l          ; for show/hide the cloned chart in MiniDesigner()
Global Dim aCurColors.l(10)  ; for UI in MiniDesigner()
Global Dim aTimerData.d(19)  ; for TimerChart
Global nIsChart2.l           ; is second chart existing?
Global hCursorWait.l

Declare.l MiniDesigner(hParent.l)
Declare.l COMBOGETSELDATA(nCtrlID.l)
Declare   COMBOSETINDEXDATA(nCtrlID.l,nData.l)                                           
Declare.l OptGet(nLower.l,nUpper.l)
Declare   CheckSet(nCtrlID.l,nState.l)
Declare.l CheckGet(nCtrlID.l)
Declare.s ReadColors(nIndex.l)
Declare.l COMBOADDLINE(nCtrlID.l,sText.s,nData.l=0)
                                           
Procedure.l IIF(a.l,b.l,c.l)
  If a
    ProcedureReturn b
  Else
    ProcedureReturn c
  EndIf
EndProcedure

Procedure.s IIFS(a.l,b.s,c.s)
  If a
    ProcedureReturn b
  Else
    ProcedureReturn c
  EndIf
EndProcedure

Procedure.l LO(Type.l,*Value.l)
  Protected Result.l
  
  Select Type
    Case #PB_Byte
      Result=PeekB(*Value+0)
    Case #PB_Word
      Result=PeekW(*Value+0)
    Case #PB_Long
      Result=PeekL(*Value+0)
  EndSelect
  
  ProcedureReturn Result
EndProcedure

Procedure.l HI(Type.l,*Value.l)
  Protected Result.l
  
  Select Type
    Case #PB_Byte
      Result=PeekB(*Value+1)
    Case #PB_Word
      Result=PeekW(*Value+2)
    Case #PB_Long
      Result=PeekL(*Value+4)
  EndSelect
  
  ProcedureReturn Result
EndProcedure

Procedure.w LOWRD(*Value.l)
  ProcedureReturn PeekW(*Value+0)
EndProcedure

Procedure.w HIWRD(*Value.l)
  ProcedureReturn PeekW(*Value+2)
EndProcedure

Procedure.l Hex2Dec(h$)
  h$=UCase(RemoveString(h$,"$"))
  For r=1 To Len(h$)
    d<<4 : a$=Mid(h$,r,1)
    If Asc(a$)>60
      d+Asc(a$)-55
    Else
      d+Asc(a$)-48
    EndIf
  Next
  ProcedureReturn d
EndProcedure

Procedure.l MAX(a,b)
  If a>b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure

Procedure.l MIN(a,b)
  If a<b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure

Procedure.l Timer_Proc(hWnd, uMsg, wParam, lParam)
  If uMsg=#WM_TIMER ; every time a timer message comes in (see TimerChart)
    For i = 0 To 18
      aTimerData(i) = aTimerData(i+1)
    Next    
    aTimerData(19) = RMC_RND(10, 680) ; Function in rmchart.dll, returns a random value between 10 and 680
    RMC_SetSeriesData(#ID_RMC1,1,1,@aTimerData(0),20) ; Set the new data values
    RMC_Draw(#ID_RMC1)                          ; (Re)draw the chart                                   
  EndIf
EndProcedure

Procedure ExportTheChart(hDlg.l, nCtrlID.l)
  Protected sFilter.s, Filename.s
  
  sFilter="Graphic Files (*.jpg*.png)|*.png;*.jpg;*.jpeg;|ALL Files (*.*)|*.*"
  Filename=SaveFileRequester("Export Chart","",sFilter,0)
  If Filename<>""
    RMC_Draw2File(nCtrlID,Filename)
  EndIf
EndProcedure

Procedure.l PrinterDialog1(hWnd.l,Flags.l,nCopies.w,nFromPage.w,nToPage.w,nMinPage.w,nMaxPage.w)
  Protected pd.PRINTDLG
  Protected save_hDevMode.l
  Protected save_hDevNames.l
  
  pd\lStructSize = SizeOf(pd)
  pd\hDevMode    = save_hDevMode
  pd\hDevNames   = save_hDevNames
  pd\hWndOwner   = hWnd
  pd\Flags       = Flags | #PD_SHOWHELP | #PD_RETURNDC
  pd\nCopies     = nCopies
  pd\nFromPage   = MAX(nFromPage, nMinPage)
  pd\nToPage     = MAX(MIN(nToPage, nMaxPage), nMaxPage)
  pd\nMinPage    = nMinPage
  pd\nMaxPage    = nMaxPage
  If PrintDlg_(pd)
    ProcedureReturn pd\hDC
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure ShowInfo(*TINFO.RMC_INFO)
  ; Is called from the Callback DlgCallback() every time you click with the left mousebutton onto the chart
  Protected sInfo.s
  
  sInfo+"Info about the mousepointer:"+#CRLF$
  sInfo+"------------------------------"+#CRLF$
  sInfo+"X position: "+#TAB$+Str(*TINFO\nXPos)+#CRLF$
  sInfo+"Y position: "+#TAB$+Str(*TINFO\nYPos)
  If *TINFO\nRegionIndex>0
    sInfo+#CRLF$+#CRLF$+"Info about the region:"+#CRLF$
    sInfo+"------------------------------"+#CRLF$
    sInfo+"Regionindex:"+#TAB$+Str(*TINFO\nRegionIndex)+#CRLF$
    sInfo+"Left position:" +#TAB$+Str(*TINFO\nRLeft)+#CRLF$
    sInfo+"Top position:"+#TAB$+Str(*TINFO\nRTop)+#CRLF$
    sInfo+"Right position:"+#TAB$+Str(*TINFO\nRRight)+#CRLF$
    sInfo+"Bottom position:"+#TAB$+Str(*TINFO\nRBottom)
  EndIf
  If *TINFO\nRegionIndex<0 ; Special case: this is a CustomObject
    sInfo+#CRLF$+#CRLF$+"Info about the CustomObject:"+#CRLF$
    sInfo+"------------------------------"+#CRLF$
    sInfo+"Index:"+#TAB$+#TAB$+Str(Abs(*TINFO\nRegionIndex))+#CRLF$
    sInfo+"Type:" +#TAB$+#TAB$
    sInfo+StringField("Text,Box,Circle,Line,Image,Symbol,Polygon",*TINFO\nChartType,",")
    sInfo+#CRLF$
    sInfo+"Left position:" +#TAB$+Str(*TINFO\nRLeft)+#CRLF$
    sInfo+"Top position:"+#TAB$+Str(*TINFO\nRTop)+#CRLF$
    sInfo+"Right position:"+#TAB$+Str(*TINFO\nRRight)+#CRLF$
    sInfo+"Bottom position:"+#TAB$+Str(*TINFO\nRBottom)
  EndIf
  If *TINFO\nGLeft+*TINFO\nGRight>0
    sInfo+#CRLF$ + #CRLF$ + "Info about the grid:"+#CRLF$
    sInfo+"------------------------------"+#CRLF$
    sInfo+"Left position:"+#TAB$+Str(*TINFO\nGLeft)+#CRLF$
    sInfo+"Top position:"+#TAB$+Str(*TINFO\nGTop)+#CRLF$
    sInfo+"Right position:"+#TAB$+Str(*TINFO\nGRight)+#CRLF$
    sInfo+"Bottom position:"+#TAB$+Str(*TINFO\nGBottom)+#CRLF$
    If *TINFO\nGCol>0
      Select *TINFO\nChartType
        Case #RMC_BARSINGLE To #RMC_HIGHLOW
          sInfo+"Column:" +#TAB$+#TAB$+Str(*TINFO\nGCol)+#CRLF$
          sInfo+"Row:" +#TAB$+#TAB$+Str(*TINFO\nGRow)
        Case #RMC_XYCHART
          sInfo+"Sector-index of 1. axes pair:" +#TAB$+Str(*TINFO\nGCol)
          If *TINFO\nGRow>0
            sInfo+#CRLF$+"Sector-index of 2. axes pair:"+#TAB$+Str(*TINFO\nGRow)
          EndIf
      EndSelect
    EndIf
  EndIf
  If *TINFO\nSeriesIndex>0
    sInfo+#CRLF$+#CRLF$+"Info about the series:"+#CRLF$
    sInfo+"------------------------------"+#CRLF$
    sInfo+"Seriesindex:" +#TAB$+Str(*TINFO\nSeriesIndex)+#CRLF$
    sInfo+"Dataindex:" +#TAB$+Str(*TINFO\nDataIndex)+#CRLF$
    If *TINFO\nChartType=#RMC_GRIDLESS
    Else
      sInfo+"Left position:"+#TAB$+Str(*TINFO\nSLeft)+#CRLF$
      sInfo+"Top position:"+#TAB$+Str(*TINFO\nSTop)+#CRLF$
      sInfo+"Right position:"+#TAB$+Str(*TINFO\nSRight)+#CRLF$
      sInfo+"Bottom position:"+#TAB$+Str(*TINFO\nSBottom)+#CRLF$
      If *TINFO\nChartType=#RMC_HIGHLOW
        sInfo+"Y-pos. Open point:"+#TAB$+Str(*TINFO\nSTop2)+#CRLF$
        sInfo+"Y-pos. Close point:"+#TAB$+Str(*TINFO\nSBottom2)+#CRLF$
      EndIf
    EndIf
    Select *TINFO\nChartType
      Case #RMC_BARSINGLE,#RMC_BARGROUP,#RMC_LINE,#RMC_AREA,#RMC_VOLUMEBAR,#RMC_AREA_STACKED
        sInfo+"Data value:" +#TAB$+StrD(*TINFO\nData1,2)+#CRLF$
      Case #RMC_FLOATINGBAR,#RMC_FLOATINGBARGROUP
        sInfo+"Starting data:" +#TAB$+StrD(*TINFO\nData1,2)+#CRLF$
        sInfo+"Length data:" +#TAB$+StrD(*TINFO\nData2,2)+#CRLF$
      Case #RMC_BARSTACKED,#RMC_BARSTACKED100,#RMC_LINE_INDEXED,#RMC_AREA_INDEXED,#RMC_GRIDLESS,#RMC_AREA_STACKED100
        sInfo+"Absolut data value:"+#TAB$+StrD(*TINFO\nData1,2)+#CRLF$
        sInfo+"Percent data value:"+#TAB$+StrD(*TINFO\nData2,2)+#CRLF$
      Case #RMC_XYCHART
        sInfo+"X-data value:"+#TAB$+StrD(*TINFO\nData1,2)+#CRLF$
        sInfo+"Y-data value:"+#TAB$+StrD(*TINFO\nData2,2)+#CRLF$
      Case #RMC_HIGHLOW
        sInfo+"Open data:" +#TAB$+StrD(*TINFO\nData1,2)+#CRLF$
        sInfo+"High data:" +#TAB$+StrD(*TINFO\nData2,2)+#CRLF$
        sInfo+"Low data:" +#TAB$+StrD(*TINFO\nData3,2)+#CRLF$
        sInfo+"Close data:" +#TAB$+StrD(*TINFO\nData4,2)+#CRLF$
    EndSelect
  EndIf
  If *TINFO\nGLeft+*TINFO\nGRight>0
    sInfo+#CRLF$+#CRLF$+"Data value, which is correspondent"+#CRLF$+"to this X/Y location:"+#CRLF$
    sInfo+"------------------------------"+#CRLF$
    If *TINFO\nChartType=#RMC_XYCHART
      sInfo+"X-data value of 1. axes pair: " +#TAB$+StrD(*TINFO\nVirtData1,2)+#CRLF$
      sInfo+"Y-data value of 1. axes pair: " +#TAB$+StrD(*TINFO\nVirtData2,2)+#CRLF$
      If *TINFO\nVirtData3<>0 And *TINFO\nVirtData4<>0
        sInfo+"X-data value of 2. axes pair: " +#TAB$+StrD(*TINFO\nVirtData3,2)+#CRLF$
        sInfo+"Y-data value of 2. axes pair: " +#TAB$+StrD(*TINFO\nVirtData4,2)+#CRLF$
      EndIf
    Else
      sInfo+"Data value of the 1. data-axis:" +#TAB$+StrD(*TINFO\nVirtData1,2)+#CRLF$
      If *TINFO\nVirtData2<>0
        sInfo+"Data value of the 2. data-axis:" +#TAB$+StrD(*TINFO\nVirtData2,2)+#CRLF$
      EndIf
    EndIf
  EndIf
  MessageRequester("RMChart Demo",sInfo,#MB_OK|#MB_ICONINFORMATION)
EndProcedure

;======= Grid Based ====================================================================
Procedure.l Show_Bars(hParentDlg.l)
  Protected nC.l
  Protected sTemp.s
  Protected nAverage.d,nL.l,nT.l,nR.l,nB.l
  Dim aData.d(4)
  Dim aXPoints.l(2)
  Dim aYPoints.l(2)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2 
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH)=#RMC_NO_ERROR ; create the chart control
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5)                               ; add a Region to the chart
    RMC_AddCaption(#ID_RMC1,1,"This is the chart's caption",#ColorBlue,#ColorYellow,11,#True) ; add a Caption to region 1
    RMC_AddGrid(#ID_RMC1,1,#ColorBeige,0,0,0,0,0,#RMC_BICOLOR_LABELAXIS) ; add a Grid to region 1
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,100,11) ; add a Data axis to region 1
    RMC_AddLabelAxis(#ID_RMC1,1, "Label 1*Label 2*Label 3*Label 4*Label 5",1,0,0,0,0,0,0,0,""); add a Label axis to region 1
    RMC_SetLAXLineStyle(#ID_RMC1,1,#RMC_LINESTYLENONE) ; No lines for the label axis
    sTemp="60*70*40*80*30"
    nC=RMC_Split2Double(sTemp,@aData()) ; read data values into array
    RMC_AddBarSeries(#ID_RMC1,1,@aData(0),nC,#RMC_BARSINGLE,#RMC_BAR_FLAT_GRADIENT1) ; add a Bar series To region 1
    RMC_SetSeriesColor(#ID_RMC1,1,1,#ColorRed,3) ; all bars have as default the same color, but: bar #3 gets Red
    ; Now add an average line:
    ; Calc the average and get the needed X/Y positions (nL,nT,nR,nB) for the line
    RMC_CalcAverage(#ID_RMC1,1,1,@nAverage,@nL,@nT,@nR,@nB)
    ; Add a CustomLine to show the average:
    RMC_CODash(#ID_RMC1,1,nL,nT,nR,nB,#RMC_LINE_FLAT,#ColorGreen,0,2)
    ; Draw the "legend" for the average line:
    RMC_Split2Long("480*565*565",@aXPoints(0))  ; X-Position
    RMC_Split2Long("175*175*208",@aYPoints(0))  ; Y-Position
    ; OR:
    ;aXPoints(0) = 480 : aXPoints(1) = 565 : aXPoints(2) = 565
    ;aYPoints(0) = 175 : aYPoints(1) = 175 : aYPoints(2) = 208
    RMC_COLine(#ID_RMC1,2,@aXPoints(0),@aYPoints(0),3,#RMC_LINE_FLAT,#ColorGreen,0,2,0,#RMC_ANCHOR_ARROW_OPEN)
    RMC_COText(#ID_RMC1,3," Average (" + StrD(nAverage,2) + ")",480,159)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  Else
    ProcedureReturn -1
  EndIf
EndProcedure

Procedure.l Show_BarsImage(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Protected nToolTipWidth.l
  Dim asTemp.s(0)
  Dim aData.d(4)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the Data With a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  nChangeData = #False  ; disallow data change when left mousebutton is clicked
  
  nToolTipWidth = 100 ; We want To have ToolTips, so we must set the width. To avoid them, set it To zero

  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorTransparent,#RMC_CTRLSTYLEIMAGE,#False,"seasky.jpg","",nToolTipWidth) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False)
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorTransparent,#False,0,0,0,0) 
    ;************** Add Data axis To region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,100,11,8,#ColorChalk,#ColorChalk,#RMC_LINESTYLEDOT)
    ;************** Add label axis To region 1 ***************************** 
    RMC_AddLabelAxis(#ID_RMC1,1, "Label 1*Label 2*Label 3*Label 4*Label 5",1,5,#RMC_LABELAXISBOTTOM,8,#ColorYellow,#RMC_TEXTCENTER,#ColorChalk,#RMC_LINESTYLENONE,"")
    ;************** Add Series 1 To region 1 ******************************* 
    ;****** Read Data values ******
    aData(0) = 50 : aData(1) = 70 : aData(2) = 40 : aData(3) = 60 : aData(4) = 30
    RMC_AddBarSeries(#ID_RMC1,1, @aData(0),5,#RMC_BARSINGLE,#RMC_BAR_FLAT_GRADIENT2,#True,#ColorTransparent,#False,1,#False,1,#RMC_HATCHBRUSH_OFF)
    ; -------------------------------^^^^^^^^^^^^^^^^
    ; -------------------------------This forces different
    ;                                colors For the bars
    ; Let's set some CustomToolTipTexts:
    RMC_SetCustomToolTipText(#ID_RMC1,1,1,1,"First Bar"+#CRLF$+"Value: 50"+#CRLF$+"Color: Blue")
    RMC_SetCustomToolTipText(#ID_RMC1,1,1,2,"Second Bar"+#CRLF$+"Value: 70"+#CRLF$+"Color: Green")
    RMC_SetCustomToolTipText(#ID_RMC1,1,1,3,"Third Bar"+#CRLF$+"Value: 40"+#CRLF$+"Color: Red")
    RMC_SetCustomToolTipText(#ID_RMC1,1,1,4,"Fourth Bar"+#CRLF$+"Value: 60"+#CRLF$+"Color: Yellow")
    ; Last bar gets no CustomText, so the default ToolTipText (=Value) is used
    RMC_Draw(#ID_RMC1)
  EndIf
EndProcedure

Procedure.l Show_GroupedBars(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Protected szTemp.s;{500}
  Dim asTemp.s(5)
  Dim aData.d(5)
  Protected tChart.RMC_CHART
  Protected tRegion.RMC_REGION
  Protected tCaption.RMC_CAPTION
  Protected tLegend.RMC_LEGEND
  Protected tGrid.RMC_GRID
  Protected tDataAxis.RMC_DATAAXIS
  Protected tLabelAxis.RMC_LABELAXIS
  Protected tBarSeries.RMC_BARSERIES

  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2 
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ; This example uses the alternative long notation style (with UDTs) and omits
  ; no property: the code is bigger, but it's easier To change
  ; properties for testing purposes

  ;************** Create the chart ********************** 
  tChart\nLeft        = 10  
  tChart\nTop         = 10  
  tChart\nWidth       = 600
  tChart\nHeight      = 450
  tChart\nBackColor   = #ColorDefault
  tChart\nCtrlStyle   = #RMC_CTRLSTYLEFLAT
  tChart\nToolTipWidth=200 ; We want ToolTips, so set the width
  If RMC_CreateChartI(hParentDlg, #ID_RMC1, tChart) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    tRegion\nLeft       = 5
    tRegion\nTop        = 5
    tRegion\nWidth      = -5
    tRegion\nHeight     = -5
    tRegion\sFooter     = 0
    tRegion\nShowBorder = #False
    RMC_AddRegionI(#ID_RMC1, tRegion) 
    ;************** Add grid To region 1 ***************************** 
    tGrid\nGridBackColor = #ColorDefault
    tGrid\nAsGradient    = #False
    tGrid\nLeft      = 0
    tGrid\nTop       = 0
    tGrid\nWidth     = 0
    tGrid\nHeight    = 0
    RMC_AddGridI(#ID_RMC1, 1, tGrid)
    ;************** Add Data axis To region 1 ***************************** 
    tDataAxis\nAlignment      = #RMC_DATAAXISLEFT
    tDataAxis\nMinValue       = 0
    tDataAxis\nMaxValue       = 100
    tDataAxis\nTickCount      = 11
    tDataAxis\nFontsize       = 8
    tDataAxis\nTextColor      = #ColorDefault
    tDataAxis\nLineColor      = #ColorDefault
    tDataAxis\nLineStyle      = #RMC_LINESTYLESOLID
    tDataAxis\nDecimalDigits  = 0
    tDataAxis\sUnit           = 0
    tDataAxis\sText           = 0
    RMC_AddDataAxisI(#ID_RMC1, 1, tDataAxis)
    ;************** Add label axis to region 1 ***************************** 
    tLabelAxis\nCount         = 1
    tLabelAxis\nTickCount     = 5
    tLabelAxis\nAlignment     = #RMC_LABELAXISBOTTOM
    tLabelAxis\nFontsize      = 8
    tLabelAxis\nTextColor     = #ColorDefault
    tLabelAxis\nTextAlignment = #RMC_TEXTCENTER
    tLabelAxis\nLineColor     = #ColorDefault
    tLabelAxis\nLineStyle     = #RMC_LINESTYLESOLID
    szTemp = "2000*2001*2002*2003*2004"
    RMC_AddLabelAxisI(#ID_RMC1, 1, szTemp, tLabelAxis)
    ;************** Add legend to region 1 ******************************* 
    tLegend\nLegendAlign    = #RMC_LEGEND_TOP
    tLegend\nLegendBackColor= #ColorDefault
    tLegend\nLegendStyle    = #RMC_LEGENDRECT
    tLegend\nLegendTextColor= #ColorDefault
    tLegend\nLegendFontSize = 8
    tLegend\nLegendIsBold   = #False
    szTemp = "First quarter*Second quarter*Third quarter*Fourth quarter"
    RMC_AddLegendI(#ID_RMC1, 1, szTemp, tLegend)    
    ;************** Add Series 1 to region 1 ******************************* 
    tBarSeries\nType             = #RMC_BARGROUP
    tBarSeries\nStyle            = #RMC_BAR_HOVER
    tBarSeries\nIsLucent         = #False
    tBarSeries\nColor            = #ColorDefault
    tBarSeries\nIsHorizontal     = #False
    tBarSeries\nWhichDataAxis    = 1
    tBarSeries\nValueLabelOn     = #False
    tBarSeries\nPointsPerColumn  = 1
    tBarSeries\nHatchMode        = #RMC_HATCHBRUSH_OFF
    ;****** Read data values ******
    sTemp = "30*20*40*60*10"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddBarSeriesI(#ID_RMC1, 1,@aData(0),nC, tBarSeries)
    ;************** Add Series 2 to region 1 ******************************* 
    tBarSeries\nType             = #RMC_BARGROUP
    tBarSeries\nStyle            = #RMC_BAR_HOVER
    tBarSeries\nIsLucent         = #False
    tBarSeries\nColor            = #ColorDefault
    tBarSeries\nIsHorizontal     = #False
    tBarSeries\nWhichDataAxis    = 1
    tBarSeries\nValueLabelOn     = #False
    tBarSeries\nPointsPerColumn  = 1
    tBarSeries\nHatchMode        = #RMC_HATCHBRUSH_OFF
    ;****** Read data values ******
    sTemp = "30*20*50*70*60"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddBarSeriesI(#ID_RMC1, 1,@aData(0),nC, tBarSeries)
    ;************** Add Series 3 to region 1 ******************************* 
    tBarSeries\nType             = #RMC_BARGROUP
    tBarSeries\nStyle            = #RMC_BAR_HOVER
    tBarSeries\nIsLucent         = #False
    tBarSeries\nColor            = #ColorDefault
    tBarSeries\nIsHorizontal     = #False
    tBarSeries\nWhichDataAxis    = 1
    tBarSeries\nValueLabelOn     = #False
    tBarSeries\nPointsPerColumn  = 1
    tBarSeries\nHatchMode        = #RMC_HATCHBRUSH_OFF
    ;****** Read data values ******
    sTemp = "40*10*30*20*80"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddBarSeriesI(#ID_RMC1, 1,@aData(0),nC, tBarSeries)
    ;************** Add Series 4 to region 1 ******************************* 
    tBarSeries\nType             = #RMC_BARGROUP
    tBarSeries\nStyle            = #RMC_BAR_HOVER
    tBarSeries\nIsLucent         = #False
    tBarSeries\nColor            = #ColorDefault
    tBarSeries\nIsHorizontal     = #False
    tBarSeries\nWhichDataAxis    = 1
    tBarSeries\nValueLabelOn     = #False
    tBarSeries\nPointsPerColumn  = 1
    tBarSeries\nHatchMode        = #RMC_HATCHBRUSH_OFF
    ;****** Read data values ******
    sTemp = "70*50*80*40*30"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddBarSeriesI(#ID_RMC1, 1,@aData(0),nC, tBarSeries)
    RMC_Draw(#ID_RMC1) ; Draw the chart 
  EndIf
EndProcedure

Procedure.l Show_StackedBars(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Protected nToolTipWidth.l
  Dim asTemp.s(6)
  Dim aData.d(6)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it                    
  EndIf
  
  nToolTipWidth = 100 ; We want to have ToolTips, so we must set the width. To avoid them, set it to zero
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorBisque,#RMC_CTRLSTYLE3DLIGHT,0,"","",nToolTipWidth) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,10,-5,-5,"this is the footer",#False) 
    ;************** Add caption To region 1 ******************* 
    RMC_AddCaption(#ID_RMC1,1,"Example of stacked bars",#ColorBisque,#ColorBlack,11,#True) 
    ;************** Add grid To region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorCornsilk,#False,0,0,0,0) 
    ;************** Add Data axis To region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISBOTTOM,0,50000,11,8,#ColorBlack,#ColorBlack,#RMC_LINESTYLESOLID,0,"$","This is an optional axis text") 
    ;************** Add label axis To region 1 ***************************** 
    RMC_AddLabelAxis(#ID_RMC1,1, "Label Nr. 1*Label Nr. 2*Label Nr. 3*Label Nr. 4*Label Nr. 5*Label Nr. 6",1,6,0,0,0,0,0,0,"")
    ;************** Add legend To region 1 ******************************* 
    RMC_AddLegend(#ID_RMC1,1,"Apples*Pears*Cherries*Strawberries",#RMC_LEGEND_CUSTOM_UR,#ColorLightYellow,#RMC_LEGENDRECT,#ColorBlue)
    ;************** Add Series 1 to region 1 ******************************* 
    ;****** Read data values ******
    nC = RMC_Split2Double("10000*10000*16000*12000*20000*10000",@aData())
    RMC_AddBarSeries(#ID_RMC1,1, @aData(0),nC,#RMC_BARSTACKED,#RMC_COLUMN_FLAT,#False,#ColorDarkBlue,#True)
    ;************** Add Series 2 to region 1 ******************************* 
    ;****** Read data values ******
    nC = RMC_Split2Double("5000*7000*4000*15000*10000*10000",@aData())
    RMC_AddBarSeries(#ID_RMC1,1, @aData(0),nC,#RMC_BARSTACKED,#RMC_COLUMN_FLAT,#False,#ColorDarkGreen,#True)
    ;************** Add Series 3 To region 1 ******************************* 
    ;****** Read Data values ******
    nC = RMC_Split2Double("10000*3000*12000*10000*5000*20000",@aData())
    RMC_AddBarSeries(#ID_RMC1,1, @aData(0),nC,#RMC_BARSTACKED,#RMC_COLUMN_FLAT,#False,#ColorMaroon,#True)
    ;************** Add Series 4 To region 1 ******************************* 
    ;****** Read Data values ******
    nC = RMC_Split2Double("5000*9000*12000*6000*10000*5000",@aData())
    RMC_AddBarSeries(#ID_RMC1,1, @aData(0),nC,#RMC_BARSTACKED,#RMC_COLUMN_FLAT,#False,#ColorDarkGoldenrod,#True)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l Show_FloatingBars(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetVal.l
  Protected szTemp.s;{2000}
  Dim aData.d(11)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
    
  If RMC_CreateChart(hParentDlg,#ID_RMC1,10,10,550,300,#ColorLightGray,#RMC_CTRLSTYLE3DLIGHT,#False,"","Tahoma") = #RMC_NO_ERROR
    nRetVal = RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False) 
    nRetVal = RMC_AddCaption(#ID_RMC1,1,"Birth of a Killer App",#ColorDefault,#ColorBlack,11,#True) 
    nRetVal = RMC_AddGrid(#ID_RMC1,1,#ColorPaleGoldenrod,#True,0,0,0,0,#RMC_BICOLOR_NONE) 
    ; the string labels for the data axis:
    szTemp = "04/01*04/02*04/03*04/04*04/05*04/06*04/07*04/08*04/09*04/10*04/11*04/12*05/01"
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISBOTTOM,1,13,13,8,#ColorBlack,#ColorBlack,#RMC_LINESTYLESOLID,0,"","",szTemp,#RMC_TEXTCENTER) 
    ; the labels for the label axis:
    szTemp = "Design*Development*Testing*Bug Fixing*Documentation*Marketing"
    RMC_AddLabelAxis(#ID_RMC1,1, szTemp,1,6,#RMC_LABELAXISLEFT,8,#ColorBlack,#RMC_TEXTCENTER,#ColorBlack,#RMC_LINESTYLESOLID,"") 
    ; the legend:
    szTemp = "Schedule*Reality"
    RMC_AddLegend(#ID_RMC1,1,szTemp,#RMC_LEGEND_CUSTOM_UR,#ColorLightBlue,#RMC_LEGENDRECT,#ColorMediumBlue,8,#False) 
    ; data for the first series, each bar has two data points, the start value and the length value:
    aData(0) = 1 : aData(1) = 3  ; first bar starts at 1 and has a length of 3
    aData(2) = 4 : aData(3) = 6  ; second bar starts at 4 and has a length of 6
    aData(4) = 6 : aData(5) = 4 
    aData(6) = 7 : aData(7) = 4 
    aData(8) = 9 : aData(9) = 3
    aData(10) = 10 : aData(11) = 3
    RMC_AddBarSeries(#ID_RMC1,1,@aData(0), 12,#RMC_FLOATINGBARGROUP,#RMC_BAR_HOVER,#False,#ColorPaleGreen,#True,1,#RMC_VLABEL_NONE,1,#RMC_HATCHBRUSH_OFF) 
    ; data for the second series, each bar has two data points, the start value and the length value:
    aData(0) = 1 : aData(1) = 0.5 : aData(2) = 1.5 : aData(3) = 10.5 : aData(4) = 12
    aData(5) = 1 : aData(6) = 12 : aData(7) = 1 : aData(8) = 12.5 : aData(9) = 0.5
    aData(10) = 2 : aData(11) = 11
    RMC_AddBarSeries(#ID_RMC1,1,@aData(0), 12,#RMC_FLOATINGBARGROUP,#RMC_BAR_HOVER,#False,#ColorOrangeRed,#True,1,#RMC_VLABEL_NONE,2,#RMC_HATCHBRUSH_OFF) 
    RMC_Draw(#ID_RMC1)
  EndIf
EndProcedure

Procedure.l Show_Line(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Protected nFirst.l, nLast.l, nL.l, nT.l, nR.l, nB.l
  Dim asTemp.s(0)
  Dim aData.d(20)
  Dim aPPC.l(0)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #True ; allow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,0,0,0,"","") = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"Click with the left mousebutton into the grid!\C11")
    ;************** Add caption to region 1 ******************* 
    RMC_AddCaption(#ID_RMC1,1,"Simple line",#ColorAquamarine,#ColorBlack,10,#True) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorBeige) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,100,11) 
    ;************** Add label axis to region 1 ***************************** 
    RMC_AddLabelAxis(#ID_RMC1,1, "",1,20,0,0,0,0,0,0,"") 
    ;************** Add Series 1 to region 1 ******************************* 
    ;****** Read data values ******
    sTemp = "15*25*30*22*75*45*65*75*40*35*20*45*80*90*70*65*25*10*30*20"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),nC, 0,0,#RMC_LINE,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE_AREA,#False,#ColorDefault,#RMC_SYMBOL_POINT,1,#True,#RMC_HATCHBRUSH_OFF)
    ; Now add a trend line:
    ; Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
    RMC_CalcTrend(#ID_RMC1,1,1,@nFirst,@nLast,@nL,@nT,@nR,@nB)
    ; Add a CustomLine to show the trend:
    RMC_CODash(#ID_RMC1,1,nL,nT,nR,nB,#RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,#ColorRed,#ColorGreen),0,2,0,#RMC_ANCHOR_ARROW_CLOSED)
    ; Draw the "legend" for the trend line:
    RMC_CODash(#ID_RMC1,2,470,11,500,11,#RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,#ColorRed,#ColorGreen),0,2)
    RMC_COText(#ID_RMC1,3,"Trend",505,5)
    ; Draw the chart
    RMC_Draw(#ID_RMC1)
  EndIf
EndProcedure

Procedure.l Show_3Lines(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Dim asTemp.s(0)
  Dim aData.d(300)
  Dim aPPC.l(0)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ; This one reads the data from *.csv-files:

  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorPaleGreen,#RMC_CTRLSTYLEFLATSHADOW,0,"","") = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,10,-5,-5,"data on a weekly basis. source: www.yahoo.com",#False) 
    ;************** Add caption to region 1 ******************* 
    RMC_AddCaption(#ID_RMC1,1,"Performance of DOW JONES, DAX and NASDAQ from January 2000 to end of June 2004",#ColorPaleGreen,#ColorDarkBlue,9,#True) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorLightBlue,#True,0,0,0,0) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,0,11,8,#ColorDarkBlue,#ColorDarkSlateGray,#RMC_LINESTYLEDOT,#True,"%","2nd January 2000 = 100%") 
    ;************** Add label axis to region 1 ***************************** 
    RMC_AddLabelAxis(#ID_RMC1,1, "2000*2001*2002*2003*2004",1,5,#RMC_LABELAXISBOTTOM,8,#ColorDarkBlue,#RMC_TEXTCENTER,#ColorDarkSlateGray,#RMC_LINESTYLEDOT,"") 
    ;************** Add legend to region 1 ******************************* 
    RMC_AddLegend(#ID_RMC1,1,"DOW JONES*DAX*NASDAQ",#RMC_LEGEND_CUSTOM_UR,#ColorPaleTurquoise,#RMC_LEGENDRECT,#ColorDarkBlue,8,#False) 
    ;************** Add Series 1 to region 1 ******************************* 
    ;****** Read points per column ******
    aPPC(0) = 52
    ;****** Read data values ******
    ;nC = RMC_ReadDataFromFile(aData(),"dow00-04.csv","234,1","5",",")
    RMC_AddLineSeries(#ID_RMC1,1, @aData(0),0, @aPPC(0),1,#RMC_LINE_INDEXED,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE,#False,#ColorBlue,#RMC_SYMBOL_NONE,1,#False,#RMC_HATCHBRUSH_OFF)
    nC = RMC_SetSeriesDataFile(#ID_RMC1,1,1,"dow00-04.csv","-1,1","5",",",0)
    ;************** Add Series 2 to region 1 ******************************* 
    ;****** Read data values ******
    ;nC = RMC_ReadDataFromFile(aData(),"dax00-04.csv","235,1","5",",")
    RMC_AddLineSeries(#ID_RMC1,1, @aData(0),0, @aPPC(0),1,#RMC_LINE_INDEXED,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE,#False,#ColorCrimson,#RMC_SYMBOL_NONE,1,#False,#RMC_HATCHBRUSH_OFF)
    nC = RMC_SetSeriesDataFile(#ID_RMC1,1,2,"dax00-04.csv","-1,1","5",",",0)
    ;************** Add Series 3 to region 1 ******************************* 
    ;****** Read data values ******
    ;nC = RMC_ReadDataFromFile(aData(),"nasdaq00-04.csv","234,1","5",",")
    RMC_AddLineSeries(#ID_RMC1,1, @aData(0),0, @aPPC(0),1,#RMC_LINE_INDEXED,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE,#False,#ColorBlack,#RMC_SYMBOL_NONE,1,#False,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,3,"nasdaq00-04.csv","-1,1","5",",",0)
    ; Add some CustomObjects
    RMC_COText(#ID_RMC1,1,"09/11/2001",287,117,80,22,0,#ColorLightGreen,0,150,0,0,"CB")
    RMC_CODash(#ID_RMC1,2,327,141,256,243,0,#ColorLightGreen,0,2,0,#RMC_ANCHOR_ARROW_OPEN)
    RMC_CODash(#ID_RMC1,3,327,141,256,294,0,#ColorLightGreen,0,2,0,#RMC_ANCHOR_ARROW_OPEN)
    RMC_CODash(#ID_RMC1,4,327,141,256,352,0,#ColorLightGreen,0,2,0,#RMC_ANCHOR_ARROW_OPEN)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l AddMoveAverage(Array aData.d(1), nPeriod.l, nColor.l)
  Protected i.l, x.l
  Protected nCount.l, nRetval.l, y.l, z.l
  Protected tLineSeries.RMC_LINESERIES
  Dim aPPC.l(0)
  Dim aData1.d(0)
  
  nCount = PeekL(@aData(0)-8) ; UBOUND in PureBasic ;-) ABBKlaus 8.2.2008 00:58
  ReDim aData1.d(nCount+1)
  
  For i = 1 To nCount
    If i < nPeriod                 ; If no data available for building the average
      aData1(i) = #RMC_NO_DATA   ; add the "NoData" Symbol
    Else
      y = (i-nPeriod) : z = i-1
      For x = y To z
        aData1(i) = aData1(i)+aData(x)
      Next
      aData1(i) = aData1(i) / nPeriod
    EndIf
  Next
  
  tLineSeries\nType             = #RMC_LINE
  tLineSeries\nStyle            = #RMC_LINE_FLAT
  tLineSeries\nLineStyle        = #RMC_LSTYLE_SPLINE
  tLineSeries\nColor            = nColor
  aPPC(0) = 52 
  ProcedureReturn RMC_AddLineSeriesI(#ID_RMC1, 1, @aData1(1), nCount,@aPPC(0),1, tLineSeries)
EndProcedure

Procedure.l Show_MissingData(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nDataCount.l
  Protected nRetVal.l
  Protected sTemp.s
  Protected szTemp.s;{2000}
  Protected nToolTipWidth.l
  Dim aData.d(20)
  Dim aData2.d(20)
  Dim aPPC.l(0)
  Dim aDates.s(999)
  
  HideGadget(#ID_SCROLL,1)
  KillTimer_(hParentDlg,1) ; Kill the timer 
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  nToolTipWidth = 100 ; We want to have ToolTips, so we must set the width. To avoid them, set it to zero
  
  ;************** Create the chart **********************
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorDefault,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma",nToolTipWidth) = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False)
    ;************** Add caption to region 1 *******************
    RMC_AddCaption(#ID_RMC1,1,"DAX on a weekly base with two moving averages and different ToolTips",0,#ColorDarkBlue,9,#True)
    ;************** Add grid to region 1 *****************************
    RMC_AddGrid(#ID_RMC1,1,#ColorDefault,#False,0,0,0,0,#RMC_BICOLOR_NONE)
    ;************** Add data axis to region 1 *****************************
    ; We only want to show every second tick with a value label, so we format a string, where every second label is empty
    szTemp = "2000**2400**2800**3200**3600**4000**4400**4800**5200**5600**6000**6400**6800**7200**7600**8000"
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,2000,8000,31,8,#ColorDefault,#ColorDefault,#RMC_LINESTYLESOLID,0,"","",szTemp,#RMC_TEXTCENTER)
    ;************** Add label axis to region 1 *****************************
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    RMC_AddLabelAxis(#ID_RMC1,1, szTemp,1,7,#RMC_LABELAXISBOTTOM,8,#ColorDefault,#RMC_TEXTCENTER,#ColorDefault,#RMC_LINESTYLESOLID,"")
    ;************** Add Series 1 to region 1 *******************************
    aPPC(0) =  52  ; Points per column: weekly data,so 52
    ;nC = RMC_ReadDataFromFile(aData(),"dax00-06.csv","-1,1","5",",",0) ; Read the closing values
    ;RMC_ReadStringFromFile(aDates(),"dax00-06.csv","-1,1","1",",",0) ; Read the dates
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE,#False,#ColorNavy,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,1,"dax00-06.csv","-1,1","5",",",0)
    
    AddMoveAverage(aData(),20,#ColorRed)   ; Add a moving average, which comprises 20 data points ...
    AddMoveAverage(aData(),50,#ColorGreen) ; ... and one which comprises 50 data points
    
    For i = 1 To nC ; Number of closing values
      szTemp = "Date: " + aDates(i-1)+#CRLF$+"Close: " +StrD(aData(i-1),2) ; Build our own ToolTipText
      RMC_SetCustomToolTipText(#ID_RMC1,1,1,i,szTemp)                              ; and add it
    Next    
    
    RMC_CODash(#ID_RMC1,1,74,69,193,69,0,#ColorRed,0,2,#RMC_ANCHOR_ARROW_OPEN,0)
    RMC_COText(#ID_RMC1,2,"Period = 20",195,61,0,0,0,0,0,0,0,0,"CB")
    
    RMC_CODash(#ID_RMC1,3,125,94,193,94,0,#ColorGreen,0,2,#RMC_ANCHOR_ARROW_OPEN,0)
    RMC_COText(#ID_RMC1,4,"Period = 50",195,87,0,0,0,0,0,0,0,0,"CB")
    
    RMC_COText(#ID_RMC1,5,"Move the mouse pointer over the blue line to see the CustomToolTips."+#CRLF$+"Both average lines have standard ToolTips.",300,50,250,65,#RMC_BOX_GRADIENTH_SHADOW,#ColorPowderBlue,0,200,0,0,"C9")
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l Show_BarsAndLine(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Protected szTemp.s;{500}
  Dim asTemp.s(0)
  Dim aData.d(20)
  Dim aPPC.l(0)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart **********************
  If RMC_CreateChart(hParentDlg,#ID_RMC1,10,10,670,450,#ColorCornflowerBlue,#RMC_CTRLSTYLEFLATSHADOW,0,"","") = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"data source: F.A.Z",#False)
    ;************** Add caption To region 1 *******************
    RMC_AddCaption(#ID_RMC1,1,"The world's 10 biggest industrial companies 2003",#ColorCoral,#ColorFloralWhite,12,#True)
    ;************** Add grid To region 1 *****************************
    RMC_AddGrid(#ID_RMC1,1,#ColorAzure,#True,0,0,0,0)
    ;************** Add Data axis To region 1 *****************************
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,100000,250000,11,9,#ColorCornsilk,#ColorBlack,#RMC_LINESTYLESOLID,0,"$","Total turnover in Mill. Dollar")
    ;************** Add second Data axis To region 1 *****************************
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISRIGHT,0,0,0,0,0,0,0,2,"%","Net operating margin")
    ;************** Add label axis To region 1 *****************************
    szTemp="Exxon Mobil*Royal Dutch / Shell*BP*General Motors*Daimler Chrysler*Ford Motor*Toyota Motor*"
    szTemp+"General Electric*TOTAL*Chevron Texaco"
    RMC_AddLabelAxis(#ID_RMC1,1, szTemp,1,10,#RMC_LABELAXISBOTTOM,8,#ColorCornsilk,#RMC_TEXTCENTER,#ColorBlack,#RMC_LINESTYLESOLID,"")
    ;************** Add Series 1 to region 1 *******************************
    ;****** Read data values ******
    sTemp = "242365*235598*232571*185524*170457*164196*149321*132797*130067*119703"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddBarSeries(#ID_RMC1,1,@aData(0),nC,#RMC_BARSINGLE,#RMC_BAR_FLAT_GRADIENT2,#False,#ColorGold,#False,1,#False,1,#RMC_HATCHBRUSH_OFF)
    ;************** Add Series 2 to region 1 *******************************
    ;****** Read data values ******
    sTemp = "8.9*4.1*4.4*2.1*.3*.3*5.9*11.3*6.7*6"
    nC = RMC_Split2Double(sTemp,@aData())
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),nC,0,0,#RMC_LINE,#RMC_LINE_CABLE,#RMC_LSTYLE_LINE,#False,#ColorGreen,#RMC_SYMBOL_BULLET,2,#True,#RMC_HATCHBRUSH_OFF)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l Show_Pie(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetVal.l
  Protected sTemp.s
  Protected szTemp.s;{2000}
  Dim aData.d(4)
  Dim aColor.l(4)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorTransparent,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma", 100, #ColorDefault) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False) 
    ;************** Add Series 1 To region 1 ******************************* 
    ;****** Read color values ******
    ReDim aColor(3)
    aColor(0) = #ColorMaroon
    aColor(1) = #ColorMediumBlue
    aColor(2) = #ColorCrimson
    aColor(3) = #ColorDefault
    ;****** Read data values ******
    ReDim aData.d(3)
    aData(0) = 80 : aData(1) = 50 : aData(2) = 60 : aData(3) = 30
    RMC_AddGridlessSeries(#ID_RMC1,1,@aData(0),4,@aColor(0),4,#RMC_PIE_3D_GRADIENT,#RMC_HALF_TOP,0,#False,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF, 0) 
    ;************** Add CustomObjects ******************************* 
    szTemp = "This is a 3D pie with semicricle alignment, tooltips, a custom text and a discreet watermark."
    RMC_COText(#ID_RMC1, 1, szTemp,  100,  270,  400,  50, #RMC_BOX_3D_SHADOW, #ColorMoccasin, #ColorDefault,  0, #RMC_LINE_HORIZONTAL, #ColorMaroon, "09C")
    RMC_SetWatermark("RMChart",#ColorAutumnOrange,25,1,#RMC_USERFONTSIZE)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

;======= None-Grid based ====================================================================
Procedure.l Show_Donut(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Dim asTemp.s(0)
  Dim aData.d(5)
  Dim aColor.l(0)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ; No individual color values are defined, so the internal colors are used in this one:
  
  ;************** Create the chart **********************
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorTransparent,#RMC_CTRLSTYLEIMAGETILED,#False,"paper.jpg","",0,0) = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False)
    ;************** Add legend To region 1 *******************************
    RMC_AddLegend(#ID_RMC1,1,"Apples*Citrons*Bananas*Cherries",#RMC_LEGEND_ONVLABELS,#ColorGainsboro,#RMC_LEGENDNORECT,#ColorBlue,8,#True)
    ;************** Add Series 1 To region 1 *******************************
    ;****** Read Data values ******
    nC = RMC_Split2Double("40*30*60*20",@aData())
    RMC_AddGridlessSeries(#ID_RMC1,1,@aData(0),nC,0,0,#RMC_DONUT_GRADIENT,#RMC_FULL,0,#False,#RMC_VLABEL_TWIN,#RMC_HATCHBRUSH_OFF)
    ; Add a CustomObject
    RMC_COText(#ID_RMC1,1,"With CustomObjects you can place text wherever you want!",230,175,140,100,0,0,0,0,0,#ColorRed,"12C")
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l Show_XY2Series(hParentDlg.l)
  Protected i.l
  Protected nCX.l
  Protected nCY.l
  Protected nRetval.l
  Protected sTemp.s
  Dim asTemp.s(0)
  Dim aData.d(4)
  Dim aData2.d(4)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorAliceBlue,#RMC_CTRLSTYLEFLATSHADOW,0,"","") = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False)
    ;************** Add caption To region 1 *******************
    RMC_AddCaption(#ID_RMC1,1,"Two XY series aligned to 2 different XY-axes pairs",#ColorBlue,#ColorAntiqueWhite,10,#True)
    ;************** Add grid To region 1 *****************************
    RMC_AddGrid(#ID_RMC1,1,#ColorBeige,#False,0,0,0,0)
    ;************** Add first X axis To region 1 *****************************
    RMC_AddXAxis(#ID_RMC1,1,#RMC_XAXISBOTTOM,0,100,11,8,#ColorBlue,#ColorBlue,#RMC_LINESTYLEDOT,0,"","First X axis","")
    ;************** Add first Y axis To region 1 *****************************
    RMC_AddYAxis(#ID_RMC1,1,#RMC_YAXISLEFT,0,100,11,8,#ColorBlue,#ColorBlue,#RMC_LINESTYLEDOT,0,"","First Y axis","")
    ;************** Add second X axis To region 1 *****************************
    RMC_AddXAxis(#ID_RMC1,1,#RMC_XAXISTOP,0,10,5,8,#ColorCoral,#ColorCoral,#RMC_LINESTYLEDASH,2,"","Second X axis","")
    ;************** Add second Y axis To region 1 *****************************
    RMC_AddYAxis(#ID_RMC1,1,#RMC_YAXISRIGHT,0,10,5,8,#ColorCoral,#ColorCoral,#RMC_LINESTYLEDASH,2,"","Second Y axis","")
    ;************** Add Series 1 To region 1 *******************************
    ;****** Read X-Data values ******
    nCX = RMC_Split2Double("20*30*60*70*90",@aData())
    ;****** Read Y-data values ******
    nCY = RMC_Split2Double("40*20*70*10*60",@aData2())
    RMC_AddXYSeries(#ID_RMC1,1,@aData(0),nCX,@aData2(0),nCY,#ColorDefault,#RMC_XY_SYMBOL,0,#RMC_SYMBOL_BULLET,#RMC_XAXISBOTTOM,#RMC_YAXISLEFT)
    ;************** Add Series 2 to region 1 *******************************
    ;****** Read X-data values ******
    nCX = RMC_Split2Double("2.5*4.5*5.5*7.5*1.0",@aData())
    ;****** Read Y-data values ******
    nCY = RMC_Split2Double("7.5*5.5*5.5*2.5*5.0",@aData2())
    RMC_AddXYSeries(#ID_RMC1,1,@aData(0),nCX,@aData2(0),nCY,#ColorCoral,#RMC_XY_SYMBOL,0,#RMC_SYMBOL_DIAMOND,#RMC_XAXISTOP,#RMC_YAXISRIGHT,#RMC_VLABEL_DEFAULT)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure


;======= XY ====================================================================
Procedure.l Show_SimpleXY(hParentDlg.l)
  Protected nRetVal.l
  Protected sTemp.s
  Dim aData.d(9)
  Dim aData2.d(9)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the Data With a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart **********************
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorSteelBlue,#RMC_CTRLSTYLEFLAT,#False) = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False)
    ;************** Add caption To region 1 *******************
    RMC_AddCaption(#ID_RMC1,1,"Simple XY chart",#ColorAliceBlue,#ColorBlack,10,#True)
    ;************** Add grid To region 1 *****************************
    RMC_AddGrid(#ID_RMC1,1,#ColorDarkBlue,#False,0,0,0,0)
    ;************** Add first X axis To region 1 *****************************
    RMC_AddXAxis(#ID_RMC1,1,#RMC_XAXISBOTTOM,0,100,11,8,#ColorBlanchedAlmond,#ColorWhite,#RMC_LINESTYLENONE,0,"","X Axis","")
    ;************** Add first Y axis To region 1 *****************************
    RMC_AddYAxis(#ID_RMC1,1,#RMC_YAXISLEFT,0,100,11,8,#ColorBlanchedAlmond,#ColorBlack,#RMC_LINESTYLENONE,0,"","Y Axis","")
    ;************** Add Series 1 to region 1 *******************************
    ;****** Read X-data values ******
    aData(0) = 10 : aData(1) = 20 : aData(2) = 30 : aData(3) = 40 : aData(4) = 50
    aData(5) = 60 : aData(6) = 70 : aData(7) = 80 : aData(8) = 90 : aData(9) = 10
    ;****** Read Y-data values ******
    aData2(0) = 10 : aData2(1) = 30 : aData2(2) = 50 : aData2(3) = 70 : aData2(4) = 90
    aData2(5) = 70 : aData2(6) = 50 : aData2(7) = 30 : aData2(8) = 10 : aData2(9) = 10
    RMC_AddXYSeries(#ID_RMC1,1,@aData(0),10,@aData2(0),10,#ColorWhiteSmoke,#RMC_XY_LINE,#RMC_LSTYLE_LINE,#RMC_SYMBOL_STAR,#RMC_XAXISBOTTOM,#RMC_YAXISLEFT, #RMC_VLABEL_NONE)
    RMC_SetWatermark(#RMC_USERWM,#RMC_USERWMCOLOR,#RMC_USERWMLUCENT,#RMC_USERWMALIGN,#RMC_USERFONTSIZE)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

;======= Miscellaneous ====================================================================
Procedure.l Build_ScrollChart(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected tChart.RMC_CHART
  Protected tRegion.RMC_REGION
  Protected tCaption.RMC_CAPTION
  Protected tLegend.RMC_LEGEND
  Protected tGrid.RMC_GRID
  Protected tDataAxis.RMC_DATAAXIS
  Protected tLabelAxis.RMC_LABELAXIS
  Protected tBarSeries.RMC_BARSERIES
  Protected tLineSeries.RMC_LINESERIES
  Protected hOldCursor.l
  Dim aPPC.l(0)
  
  HideGadget(#ID_SCROLL,0)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  ;siH\cbSize = SizeOf(siH)
  ;siH\fMask = #SIF_RANGE | #SIF_PAGE
  ;siH\nMin = 1
  ;siH\nMax = 1256           ; 1256 days total
  ;siH\nPage = 21            ; 21 days shall be painted 
  ;lScrH=GadgetID(#ID_SCROLL)
  ;SetScrollInfo_(lScrH, #SB_CTL, siH, #True)
  SetGadgetAttribute(#ID_SCROLL,#PB_ScrollBar_Minimum,1)
  SetGadgetAttribute(#ID_SCROLL,#PB_ScrollBar_Maximum,1256)
  SetGadgetAttribute(#ID_SCROLL,#PB_ScrollBar_PageLength,21)
  
  hOldCursor = SetCursor_(hCursorWait)
  
  ; This example shows, how you can change the data of a chart 'on the fly' without
  ; the necessarity of a complete rebuild of the chart.
  ; This function is only called once, from Function DlgCallback, before setting
  ; the initial data range for the chart.
  ; The call to RMC_Draw for showing the chart also happens in Function DlgCallback,
  ; behind 'Case #ID_MSC1', after setting the first data range for the chart.
  ; When you scroll the chart, the chart gets refreshed with new data also
  ; in the Callback, behind 'Case #WM_VSCROLL'
  
  ;************** Create the chart ********************** 
  tChart\nLeft        = 10  
  tChart\nTop         = 10  
  tChart\nWidth       = 650
  tChart\nHeight      = 500
  tChart\nBackColor   = #ColorDarkTurquoise
  tChart\nCtrlStyle   = #RMC_CTRLSTYLEFLAT
  tChart\nToolTipWidth= 100 ; We want to have ToolTips, so set the width
  If RMC_CreateChartI(hParentDlg, #ID_RMC1, tChart) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    tRegion\nLeft       = 5
    tRegion\nTop        = 5
    tRegion\nWidth      = -5
    tRegion\nHeight     = -5
    PokeS(@tRegion\sFooter,"data source: www.yahoo.com",-1,#PB_Ascii)
    tRegion\nShowBorder = #False
    RMC_AddRegionI(#ID_RMC1, tRegion) 
    ;************** Add caption to region 1 ******************* 
    PokeS(@tCaption\sText,"Dow Jones 2000 - 2004",-1,#PB_Ascii)
    tCaption\nBackColor = #ColorDefault
    tCaption\nTextColor = #ColorDefault
    tCaption\nFontSize  = 13
    tCaption\nIsBold    = #True
    RMC_AddCaptionI(#ID_RMC1, 1, tCaption)
    ;************** Add grid to region 1 ***************************** 
    tGrid\nGridBackColor = #ColorLightSkyBlue
    tGrid\nAsGradient    = #True
    tGrid\nLeft      = 0
    tGrid\nTop       = 0
    tGrid\nWidth     = 0
    tGrid\nHeight    = 0
    RMC_AddGridI(#ID_RMC1, 1, tGrid)
    ;************** Add data axis to region 1 ***************************** 
    tDataAxis\nAlignment      = #RMC_DATAAXISBOTTOM
    tDataAxis\nMinValue       = 7000
    tDataAxis\nMaxValue       = 12000
    tDataAxis\nTickCount      = 11
    tDataAxis\nFontsize       = 8
    tDataAxis\nTextColor      = #ColorDefault
    tDataAxis\nLineColor      = #ColorDefault
    tDataAxis\nLineStyle      = #RMC_LINESTYLESOLID
    tDataAxis\nDecimalDigits  = 0
    tDataAxis\sUnit           = 0
    PokeS(@tDataAxis\sText,"Closing Index (Line series)\11",-1,#PB_Ascii)
    RMC_AddDataAxisI(#ID_RMC1, 1, tDataAxis)
    ;************** Add second data axis to region 1 ***************************** 
    tDataAxis\nAlignment      = #RMC_DATAAXISTOP
    tDataAxis\nMinValue       = 0     
    tDataAxis\nMaxValue       = 30000000
    tDataAxis\nDecimalDigits  = 0
    tDataAxis\sUnit           = 0
    PokeS(@tDataAxis\sText,"Share volumes (Bar series)\11",-1,#PB_Ascii)
    RMC_AddDataAxisI(#ID_RMC1, 1, tDataAxis)
    ;************** Add label axis to region 1 ***************************** 
    tLabelAxis\nCount         = 1
    tLabelAxis\nTickCount     = 21
    tLabelAxis\nAlignment     = #RMC_LABELAXISLEFT
    tLabelAxis\nFontsize      = 8
    tLabelAxis\nTextColor     = #ColorDefault
    tLabelAxis\nTextAlignment = #RMC_TEXTCENTER
    tLabelAxis\nLineColor     = #ColorDefault
    tLabelAxis\nLineStyle     = #RMC_LINESTYLESOLID
    RMC_AddLabelAxisI(#ID_RMC1, 1, "", tLabelAxis)
    ;************** Add Series 1 to region 1 ******************************* 
    tBarSeries\nType             = #RMC_BARSINGLE
    tBarSeries\nStyle            = #RMC_BAR_HOVER
    tBarSeries\nIsLucent         = #False
    tBarSeries\nColor            = #ColorLightGoldenrod
    tBarSeries\nIsHorizontal     = #True
    tBarSeries\nWhichDataAxis    = 2
    tBarSeries\nValueLabelOn     = #False
    tBarSeries\nPointsPerColumn  = 1
    tBarSeries\nHatchMode        = #RMC_HATCHBRUSH_OFF
    RMC_AddBarSeriesI(#ID_RMC1, 1, 0,0, tBarSeries)
    ;************** Add Series 2 to region 1 ******************************* 
    tLineSeries\nType             = #RMC_LINE
    tLineSeries\nStyle            = #RMC_LINE_FASTLINE
    tLineSeries\nLineStyle        = #RMC_LSTYLE_LINE
    tLineSeries\nIsLucent         = #False
    tLineSeries\nColor            = #Red
    tLineSeries\nSeriesSymbol     = #RMC_SYMBOL_POINT_SMALL
    tLineSeries\nWhichDataAxis    = 1
    tLineSeries\nValueLabelOn     = #False
    tLineSeries\nHatchMode        = #RMC_HATCHBRUSH_OFF
    RMC_AddLineSeriesI(#ID_RMC1, 1, 0,0,0,0, tLineSeries)
    
    ; Now read the whole data set from file for both series
    ; When scrolling through the chart, the actual data range is set with RMC_SetSeriesDataRange()
    RMC_SetSeriesDataFile(#ID_RMC1,1,1, "dowdaily.csv","-1,0","3",",")
    RMC_SetSeriesDataFile(#ID_RMC1,1,2, "dowdaily.csv","-1,0","2",",")
    ; Read all labels from the file
    ; When scrolling through the chart, the actual label range is set with RMC_SetLAXLabelsRange()
    RMC_SetLAXLabelsFile(#ID_RMC1,1,"dowdaily.csv","-1,0","1",",")
  EndIf
  
  SetCursor_(hOldCursor)    
EndProcedure

Procedure.l TimerChart(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  
  nChangeData = #False ; disallow changing the data with a mouseclick                
  HideGadget(#ID_SCROLL,1)
  SetTimer_(hParentDlg, 1, 250, @Timer_Proc()) ; initialize the timer with a time-out value of 0 milliseconds ("real time")
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart **********************
  If RMC_CreateChart(hParentDlg, #ID_RMC1, 10, 10, 600, 450, #ColorBlack) = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************
    RMC_AddRegion(#ID_RMC1, 2, 2, -2, -2)
    ;************** Add grid To region 1 *****************************
    RMC_AddGrid(#ID_RMC1, 1, #ColorBlack)
    ;************** Add Data axis To region 1 *****************************
    RMC_AddDataAxis(#ID_RMC1, 1, #RMC_DATAAXISLEFT, 0, 700, 8, 7, #ColorLimeGreen, #ColorDarkGreen, #RMC_LINESTYLEDOT)
    ;************** Add label axis To region 1 *****************************
    RMC_AddLabelAxis(#ID_RMC1, 1, "", 1, 20, #RMC_LABELAXISBOTTOM, 8, #ColorBlack, #RMC_TEXTCENTER, #ColorDarkGreen, #RMC_LINESTYLESOLID, "")
    ; Get 20 random values between 100 And 600 For the initial line
    ReDim aTimerData.d(19)
    For i = 0 To 19
      aTimerData(i) = RMC_RND(10, 680) ; Function in rmchart.dll, returns a random value between 10 and 680
    Next
    RMC_AddLineSeries(#ID_RMC1, 1, @aTimerData(0), 20, 0, 0, #RMC_LINE, #RMC_LINE_FASTLINE, #RMC_LSTYLE_LINE, #False, #ColorLimeGreen)
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l Show_File(hParentDlg.l)
  Protected nRetVal.l
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChartFromFile(hParentDlg,#ID_RMC1,10,10,#False,"4 regions.rmc") = #RMC_NO_ERROR
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure    

Procedure.l Show_DataString(hParentDlg.l)
  Protected sTemp.s;{5000}
  Protected nRetVal.l
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  sTemp+"00003650|00004450|000051|000061|000071|00008-6697831|00009400|00011Tahoma|100011"
  sTemp+"|1000310|1000410|10005-5|10006-5|1000910|100101|100111|100121|100131|100181|1002"
  sTemp+"00|100217|1002215|100238|100272|100331|100341|100358|100378|100411|100482|100492"
  sTemp+"|10051-6751336|10052-15132304|10053-983041|100541|100558|10056-16777077|10057-16"
  sTemp+"777077|100586|10060-16777077|10061-1468806|100622|10180data source: www.federalr"
  sTemp+"eserve.gov + www.ecb.int|10181Prime Rates in USA und Euroland|10183#|101871999*"
  sTemp+"2000*2001*2002*2003*2004*2005*2006|110011|1100221|110035|1100434|110052|110063|1"
  sTemp+"10073|1100970|1101312|110171|11019-16744448|1102115|110221|1102396|110262|110521"
  sTemp+"2|110534.75*4.75*4.75*4.75*4.75*5*5*5.25*5.25*5.25*5.5*5.5*5.5*5.75*6*6*6.5*6.5*"
  sTemp+"6.5*6.5*6.5*6.5*6.5*6.5*5.5*5.5*5*4.5*4*3.75*3.75*3.5*3*2.5*2*1.75*1.75*1.75*1.7"
  sTemp+"5*1.75*1.75*1.75*1.75*1.75*1.75*1.75*1.25*1.25*1.25*1.25*1.25*1.25*1.25*1*1*1*1*"
  sTemp+"1*1*1*1*1*1*1*1*1*1*1.25*1.5*1.75*2*2.25*2.25*2.5*2.75*2.75*3*3.25*3.25*3.5*3.75"
  sTemp+"*3.75*4*4.25*4.5*4.5*4.75*4.75*5*5.25*5.25*5.25*5.25*5.25*5.25*5.25|120011|12002"
  sTemp+"21|120035|1200434|120052|120063|120073|1200950|1201312|120171|12019-2448096|1202"
  sTemp+"115|120221|1202396|120262|1205212|120533*3*3*2.5*2.5*2.5*2.5*2.5*2.5*2.5*3*3*3*3"
  sTemp+".25*3.5*3.75*3.75*4.25*4.25*4.5*4.5*4.75*4.75*4.75*4.75*4.75*4.75*4.75*4.5*4.5*4"
  sTemp+".5*4.25*3.75*3.75*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3."
  sTemp+"25*2.75*2.75*2.75*2.5*2.5*2.5*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*"
  sTemp+"2*2*2*2*2*2.25*2.25*2.25*2.5*2.5*2.5*2.75*2.75*3*3*3.25*3.25*3.5|010011|010054|0"
  sTemp+"100721|01014-16744448|010222|01024216*287|01025109*109|010272|010283|010012|0100"
  sTemp+"51|01010295|01011102|010191|01026USA (Federal Funds Rate)|010013|010054|0100721|"
  sTemp+"01014-10496|010222|01024260*287|01025192*192|010272|010283|010014|010051|0101029"
  sTemp+"5|01011185|010191|01026Euroland (Prime Rate)"
  
  If RMC_CreateChartFromFile(hParentDlg,#ID_RMC1,10,10,0,sTemp) = #RMC_NO_ERROR ; pass the data string instead of the file name
    RMC_Draw(#ID_RMC1) ; Draw the chart
  EndIf
EndProcedure

Procedure.l Show_Transparent(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nDataCount.l
  Protected nRetVal.l
  Protected sTemp.s
  Dim aData.d(3)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the Data With a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  
  ; In this example we use a transparent bitmap as canvas for the chart. To place it over
  ; the previous painted chart, we create a new control with ID #ID_RMC2. If we would use
  ; ID #ID_RMC1, as in all other examples, the previously painted chart would be destroyed.
  ; If you want to save or print this chart, you must change in Callback DlgCallback under
  ; #ID_EXPORT and #ID_PRINT the chart's ID.
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC2, 185, 115, 250, 200,#ColorTransparent,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma", 0, #ColorTransparent) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC2,5,5,-5,-5) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC2,1,#ColorTransparent) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC2,1,#RMC_DATAAXISLEFT,0,100,11,8,#ColorBlack,#ColorBlack,#RMC_LINESTYLENONE,0,"","","-") 
    ;************** Add label axis to region 1 ***************************** 
    RMC_AddLabelAxis(#ID_RMC2,1, "",1,4,#RMC_LABELAXISBOTTOM,8,#ColorBlack,#RMC_TEXTCENTER,#ColorBlack,#RMC_LINESTYLENONE,"") 
    ;************** Add Series 1 to region 1 ******************************* 
    ;****** Read data values ******
    aData(0) = 70 : aData(1) = 20 : aData(2) = 80 : aData(3) = 30
    nRetVal = RMC_AddBarSeries(#ID_RMC2,1,@aData(0),4,#RMC_BARSINGLE,#RMC_COLUMN_FLAT,#False,#ColorMaroon)
    ;************** Add Series 2 to region 1 ******************************* 
    ;****** Read data values ******
    aData(0) = 30 : aData(1) = 70 : aData(2) = 40 : aData(3) = 80
    RMC_AddLineSeries(#ID_RMC2,1,@aData(0),4,0,0,#RMC_LINE,#RMC_LINE_CABLE_SHADOW,#RMC_LSTYLE_SPLINE,#False,#ColorMediumBlue)
    RMC_Draw(#ID_RMC2) ; Draw the chart
    nIsChart2 = #True ; Flag for the existence of the second chart
  EndIf
EndProcedure

Procedure.l Chart2Bmp(hParentDlg.l)
  Protected i.l
  Protected nC.l
  Protected nRetval.l
  Protected sTemp.s
  Dim aData.d(4)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,#GridX,#GridY,#GridW,#GridH,#ColorTransparent,#RMC_CTRLSTYLEFLAT,#True,"","",0,#ColorTransparent) = #RMC_NO_ERROR
    ;************** Add Region 1 *****************************                                  
    ;create the chart only for exporting and make it transparent
    RMC_AddRegion(#ID_RMC1,5,5,-5,-5,"",#False)
    ;************** Add legend to region 1 ******************************* 
    RMC_AddLegend(#ID_RMC1,1,"Apples*Bananas*Pears*Cherries",#RMC_LEGEND_CUSTOM_UL,#ColorDefault,#RMC_LEGENDNORECT,#ColorDefault,8,#False) 
    ;************** Add Series 1 to region 1 ******************************* 
    ;****** Read data values ******
    nC = RMC_Split2Double("30.25*26.75*15.89*46.23",@aData())
    RMC_AddGridlessSeries(#ID_RMC1,1,@aData(0),nC,0,0,#RMC_PYRAMIDE3,#RMC_FULL,0,#False,#True,#RMC_HATCHBRUSH_OFF) 
    RMC_Draw2File(#ID_RMC1,"Demo.png") ; Save the chart
    ;If you want to print the chart without painting, 
    ;uncomment the following line:
    ;RMC_Draw2Printer(#ID_RMC1) ; Send the chart To the Default printer
    MessageRequester("RMChart Demo","Chart was saved as 'Demo.png'",#PB_MessageRequester_Ok|#MB_ICONINFORMATION)
    DisableGadget(#ID_PRINT,1)
    DisableGadget(#ID_EXPORT,1)
  EndIf
EndProcedure 

Procedure.l Show_ZoomInternal(hParentDlg.l)
  Protected nRetVal.l
  Protected szTemp.s;{2000}
  Protected hOldCursor.l
  Dim aData.d(20)
  Dim aPPC.l(0)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  hOldCursor = SetCursor_(hCursorWait)

  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,10,10,650,500,#ColorDefault,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma", 0, #ColorDefault) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,5,-5,-70,"",#False) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorDefault,#False,0,0,0,0,#RMC_BICOLOR_NONE) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,0,11,8,#ColorDefault,#ColorDefault,#RMC_LINESTYLESOLID,0,"","","",#RMC_TEXTCENTER) 
    ;************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    RMC_AddLabelAxis(#ID_RMC1,1, szTemp,1,7,#RMC_LABELAXISBOTTOM,8,#ColorDefault,#RMC_TEXTCENTER,#ColorDefault,#RMC_LINESTYLESOLID,"") 
    ;************** Add Series 1 to region 1 ******************************* 
    aPPC(0) = 254
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorGreen,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,1,"dax00-06d.csv","-1,0","3",",",0)
    ;************** Add Series 2 to region 1 ******************************* 
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorRed,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,2,"dax00-06d.csv","-1,0","4",",",0)
    ;************** Add Series 3 to region 1 *******************************     
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorBlue,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,3,"dax00-06d.csv","-1,0","7",",",0)    
    RMC_AddLegend(#ID_RMC1,1,"High*Low*Close",#RMC_LEGEND_TOP)
    szTemp="Draw a rectangle with the left mouse button pressed around the area, "
    szTemp+"which shall be zoomed, then release the button."+#CRLF$+"With a right mouse button click (backwards) and a Shift+"
    szTemp+"right mouse button click (forwards) you can browse between multiple zoom states."+#CRLF$
    szTemp+"The middle mouse button redraws the original (unzoomed) chart."
    nRetVal=RMC_COText(#ID_RMC1, 1, szTemp,  35,  435,  610,  60, #RMC_BOX_FLAT_SHADOW, #ColorDefault, #ColorDefault,  0, #RMC_LINE_HORIZONTAL, #ColorDefault, "00C")
    RMC_Zoom(#ID_RMC1,#RMC_ZOOM_INTERNAL,#ColorRed,#ColorBlue,100)
    RMC_Draw(#ID_RMC1)
  EndIf
  SetCursor_(hOldCursor)
EndProcedure

Procedure.l Show_ZoomExternal(hParentDlg.l)
  Protected nRetVal.l
  Protected szTemp.s;{2000}
  Protected hOldCursor.l
  Dim aData.d(0)
  Dim aPPC.l(0)
  
  hOldCursor = SetCursor_(hCursorWait)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,10,10,800,250,#ColorDefault,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma", 0, #ColorDefault) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,5,-100,-5,"",#False) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorDefault,#False,0,0,0,0,#RMC_BICOLOR_NONE) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,0,11,8,#ColorDefault,#ColorDefault,#RMC_LINESTYLESOLID,0,"","","",#RMC_TEXTCENTER) 
    ;************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    RMC_AddLabelAxis(#ID_RMC1,1, szTemp,1,7,#RMC_LABELAXISBOTTOM,8,#ColorDefault,#RMC_TEXTCENTER,#ColorDefault,#RMC_LINESTYLESOLID,"") 
    ;************** Add Series 1 to region 1 ******************************* 
    aPPC(0) = 254
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorGreen,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,1,"dax00-06d.csv","-1,0","3",",",0)
    ;************** Add Series 2 to region 1 ******************************* 
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorRed,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,2,"dax00-06d.csv","-1,0","4",",",0)
    ;************** Add Series 3 to region 1 *******************************     
    RMC_AddLineSeries(#ID_RMC1,1,@aData(0),0,@aPPC(0),1,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorBlue,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
    RMC_SetSeriesDataFile(#ID_RMC1,1,3,"dax00-06d.csv","-1,0","7",",",0)    
    RMC_AddLegend(#ID_RMC1,1,"High*Low*Close",#RMC_LEGEND_TOP)
    szTemp="Draw a rectangle with the left mouse button pressed around the area, "
    szTemp+"which shall be zoomed, then release the button."
    RMC_COText(#ID_RMC1, 1, szTemp,  710,  40, 80 ,150, #RMC_BOX_FLAT_SHADOW, #ColorDefault, #ColorDefault,  0, #RMC_LINE_HORIZONTAL, #ColorDefault, "00C")
    RMC_Zoom(#ID_RMC1,#RMC_ZOOM_EXTERNAL,#ColorRed,#ColorBlue,100)
    RMC_Draw(#ID_RMC1)
    ;************** Create a second chart for showing the zoomed area  ********************** 
    If RMC_CreateChart(hParentDlg,#ID_RMC2, 10, 270, 800, 300,#ColorDefault,#RMC_CTRLSTYLEFLAT, #False,"","Tahoma", 0, #ColorDefault) = #RMC_NO_ERROR
      ;************** Add Region 1 ***************************** 
      RMC_AddRegion(#ID_RMC2,5,5,-5,-5,"",#False) 
      ;************** Add grid to region 1 ***************************** 
      RMC_AddGrid(#ID_RMC2,1,#ColorDefault,#False,0,0,0,0,#RMC_BICOLOR_NONE) 
      ;************** Add data axis to region 1 ***************************** 
      RMC_AddDataAxis(#ID_RMC2,1,#RMC_DATAAXISLEFT,0,0,11,8,#ColorDefault,#ColorDefault,#RMC_LINESTYLESOLID,0,"","","",#RMC_TEXTCENTER) 
      ;************** Add label axis to region 1 ***************************** 
      szTemp = "2000*2001*2002*2003*2004*2005*2006"
      RMC_AddLabelAxis(#ID_RMC2,1, szTemp,1,7,#RMC_LABELAXISBOTTOM,8,#ColorDefault,#RMC_TEXTCENTER,#ColorDefault,#RMC_LINESTYLESOLID,"") 
      ;************** Add Series 1 to region 1 ******************************* 
      aPPC(0) = 254
      RMC_AddLineSeries(#ID_RMC2,1,@aData(0),0,0,0,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorGreen,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
      RMC_SetSeriesDataFile(#ID_RMC2,1,1,"dax00-06d.csv","-1,0","3",",",0)
      ;************** Add Series 2 to region 1 *******************************
      RMC_AddLineSeries(#ID_RMC2,1,@aData(0),0,0,0,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorRed,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
      RMC_SetSeriesDataFile(#ID_RMC2,1,2,"dax00-06d.csv","-1,0","4",",",0)
      ;************** Add Series 3 to region 1 *******************************     
      RMC_AddLineSeries(#ID_RMC2,1,@aData(0),0,0,0,#RMC_LINE,#RMC_LINE_FASTLINE,#RMC_LSTYLE_LINE,#False, #ColorBlue,#RMC_SYMBOL_NONE,1,#RMC_VLABEL_NONE,#RMC_HATCHBRUSH_OFF)
      RMC_SetSeriesDataFile(#ID_RMC2,1,3,"dax00-06d.csv","-1,0","7",",",0)    
      RMC_AddLegend(#ID_RMC2,1,"High*Low*Close",#RMC_LEGEND_TOP)
      nIsChart2 = #True
    EndIf
  EndIf
  SetCursor_(hOldCursor)   
EndProcedure

Procedure Show_ZoomedArea(*TINFO.RMC_INFO)
  Protected i.l
  Protected nFirst.l,nLast.l,nFirstCol.l,nLastCol.l,nColIndex.l,nOldColIndex.l,y.l
  Protected tINFO2.RMC_INFO
  Dim aPointsPerCol.l(0)
  
  If *TINFO\nData1 <> 0       ; if the rectangle covers data
    ; nData1 holds the information about the first series. 
    ;nFirst = LO(DWORD,@*TINFO\nData1) ; the (first) data index of the first element, which is covered by the rectangle
    ;nLast = HI(DWORD,@*TINFO\nData1)  ; the (last) data index of the last element, which is covered by the rectangle
    nFirst=RMC_GetLowPart(*TINFO\nData1)
    nLast=RMC_GetHighPart(*TINFO\nData1)
    RMC_SetSeriesDataRange(#ID_RMC2,1,1,nFirst,nLast)   ; set the new data range for series 1
    ; The three series (which show the high,low and close value of DAX at each day) belong together,
    ; so we will not check .nData2 and .nData3 for the nFirst and nLast values, they must have the same index values
    ; as for the first series. We will simply set the DataRange for series 2 and 3 the same as for series 1:
    RMC_SetSeriesDataRange(#ID_RMC2,1,2,nFirst,nLast)   ; set the new data range for series 2
    RMC_SetSeriesDataRange(#ID_RMC2,1,3,nFirst,nLast)   ; set the new data range for series 3                
    
    ; To keep it simple, we could now set the label axis to one column and show the lines evenly spread in this column,
    ; as it is always done, when using the internal zooming mode (check example "Zoom internal").
    ; Uncomment the next four lines to see the chart:
    ; RMC_SetLAXTickCount(#ID_RMC2,1,1)     ; only one column on the label axis
    ; RMC_SetLAXLabelsRange(#ID_RMC2,1,-1,-1) ; show no labels 
    ; RMC_Draw(#ID_RMC2)                    ; draw the zoomed area chart   
    ; ProcedureReturn
    
    ; But we want to show the data points of the lines in the columns of the label axis, where they belong to.
    ; so we must check each data point for it's column index, And we must count, how many Data points belong
    ; to each column:

    For i = nFirst To nLast
      RMC_GetINFO(#ID_RMC1,tINFO2,1,1,i)
      nColIndex = tINFO2\nGCol                ; ColumnIndex of the data point
      If nFirstCol=0                          ; Mark the first label for the label axis
        nFirstCol=nColIndex
      EndIf
      If nColIndex>nOldColIndex               ; New ColumnIndex? 
        y+1                                 ; Incr Column count 
        If y = 1
          ReDim aPointsPerCol.l(1)          ; (Re)Dimension the PointsPerColumn-Array
        Else
          ReDim aPointsPerCol.l(y)
        EndIf
        nOldColIndex = nColIndex
      EndIf
      aPointsPerCol(y)+1                      ; Increment the counter for the PointsPerColumn for this Column
    Next
    nLastCol = nColIndex                        ; Mark the last label for the label axis  
    
    RMC_SetLAXTickCount(#ID_RMC2,1,y)           ; Set the number of columns
    For i = 1 To 3
      RMC_SetSeriesPPColumnArray(#ID_RMC2,1,i,@aPointsPerCol(1),y) ; set the PointsPerColumn (for each series identical)
    Next
    RMC_SetLAXLabelsRange(#ID_RMC2,1,nFirstCol,nLastCol) ; Set the range for the labels on the label axis
    RMC_Draw(#ID_RMC2)                          ; Draw the zoomed area chart
  Else                        ; if the rectangle covers no data
    For i = 1 To 3
      RMC_SetSeriesDataRange(#ID_RMC2,1,i,-1,-1) ; set series range to zero
    Next    
    RMC_SetLAXTickCount(#ID_RMC2,1,1)
    RMC_SetLAXLabelsRange(#ID_RMC2,1,-1,-1)
    RMC_Draw(#ID_RMC2) ; Redraw the lower chart control  
  EndIf                        
EndProcedure

Procedure.l Show_Magnifier(hParentDlg.l)
  Protected nRetVal.l
  Protected szTemp.s;{2000}
  Protected hOldCursor.l
  Dim aData.d(0)
  Dim aPPC.l(0)
  
  hOldCursor = SetCursor_(hCursorWait)
  
  HideGadget(#ID_SCROLL,1)
  nChangeData = #False ; disallow changing the data with a mouseclick                    
  KillTimer_(hParentDlg,1) ; Kill the timer 
  If nIsChart2
    RMC_DeleteChart(#ID_RMC2)
    nIsChart2 = 0  ; If second chart is existing, delete it
  EndIf
  
  ;************** Create the chart ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC1,10,10,800,250,#ColorDefault,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma", 0, #ColorDefault) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC1,5,5,-150,-5,"",#False) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC1,1,#ColorDefault,#False,0,0,0,0,#RMC_BICOLOR_NONE) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC1,1,#RMC_DATAAXISLEFT,0,0,11,8,#ColorDefault,#ColorDefault,#RMC_LINESTYLESOLID,0,"","","",#RMC_TEXTCENTER) 
    ;************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(#ID_RMC1,1, szTemp,1,7,#RMC_LABELAXISBOTTOM,8,#ColorDefault,#RMC_TEXTCENTER,#ColorDefault,#RMC_LINESTYLESOLID,"") 
    ;************** Add Series 1 to region 1 ******************************* 
    aPPC(0) = 254
    RMC_AddHighLowSeries(#ID_RMC1,1,0,0,@aPPC(0),1)
    RMC_SetSeriesDataFile(#ID_RMC1,1,1,"dax00-06d.csv","-1,0","2-5",",",0)
    szTemp="Click with the left mouse button onto the chart and move the blue rectangle over the HighLow series. "
    szTemp+"The magnification of this area is shown in the lower chart control."+#CRLF$+#CRLF$
    szTemp+"Shift + right mouse click enlarges the rectangle, Shift + left mouse click makes it smaller."
    RMC_COText(#ID_RMC1, 1, szTemp,  670,  10,  120,  220, #RMC_BOX_FLAT_SHADOW, #ColorDefault, #ColorDefault,  0, #RMC_LINE_HORIZONTAL, #ColorDefault, "00C")
    RMC_Magnifier(#ID_RMC1,#True,20,#ColorBlue,0,100)
    RMC_Draw(#ID_RMC1)
  EndIf    
  ;************** Create a second chart for the magnifier ********************** 
  If RMC_CreateChart(hParentDlg,#ID_RMC2, 10, 270, 800, 300,#ColorDefault,#RMC_CTRLSTYLEFLAT, #False,"","Tahoma", 0, #ColorDefault) = #RMC_NO_ERROR
    ;************** Add Region 1 ***************************** 
    RMC_AddRegion(#ID_RMC2,5,5,-5,-5,"",#False) 
    ;************** Add grid to region 1 ***************************** 
    RMC_AddGrid(#ID_RMC2,1,#ColorDefault,#False,0,0,0,0,#RMC_BICOLOR_NONE) 
    ;************** Add data axis to region 1 ***************************** 
    RMC_AddDataAxis(#ID_RMC2,1,#RMC_DATAAXISLEFT,0,0,11,8) 
    ;************** Add label axis to region 1 ***************************** 
    RMC_AddLabelAxis(#ID_RMC2,1,"",0,1,#RMC_LABELAXISBOTTOM,8,#ColorBlack,#RMC_TEXTCENTER,#ColorBlack,#RMC_LINESTYLENONE,"")
    aPPC(0) = 1    
    RMC_AddHighLowSeries(#ID_RMC2,1,0,0,0,0)
    RMC_SetSeriesDataFile(#ID_RMC2,1,1,"dax00-06d.csv","-1,0","2-5",",",0)
    nIsChart2 = #True
  EndIf
  SetCursor_(hOldCursor)
EndProcedure

Procedure Show_Magnification(*TINFO.RMC_INFO)
  Protected nFirst.l, nLast.l
  
  If *TINFO\nData1 ; if the rectangle covers data
    ; nData1 holds the information about the first series. Because we have only one series,
    ; we don't have To check nData2 - nVirtData4 For the infos about other series.
    ;nFirst = LO(#Long,@*TINFO\nData1) ; the (first) data index of the first element, which is covered by the rectangle
    ;nLast = HI(#Long,@*TINFO\nData1)  ; the (last) data index of the last element, which is covered by the rectangle
    nFirst=RMC_GetLowPart(*TINFO\nData1)
    nLast =RMC_GetHighPart(*TINFO\nData1)
    RMC_SetSeriesDataRange(#ID_RMC2,1,1,nFirst,nLast)   ; set the new data range
    RMC_Draw(#ID_RMC2) ; Redraw the lower chart control
  Else                        ; if the rectangle covers no data
    RMC_SetSeriesDataRange(#ID_RMC2,1,1,-1,-1) ; set series range to zero
    RMC_Draw(#ID_RMC2) ; Redraw the lower chart control  
  EndIf
EndProcedure
    
Procedure DlgCallback(CBHNDL.l, CBMSG.l, CBWPARAM.l, CBLPARAM.l)
  Protected i.l
  Protected nError.l
  Protected nResult.l
  Protected Result.l
  Protected hDC.l
  Protected x.l
  Protected sLines.s;{20}
  Protected *TINFO.RMC_INFO
  Protected nFirst.d,nLast.d,nData.l,nL.l,nT.l,nR.l,nB.l,nPos.l,nC.l
  Protected CBCTL.w,CBCTLMSG.w
  Dim aData1.d(0)
  Dim aData2.d(0)
  Dim aLabels.s(0)

  Static nLButtonDown.l, nOldX.l, nOldY.l
  
  Result=#PB_ProcessPureBasicEvents
  
  CBCTL = PeekW(@CBWPARAM+0)
  CBCTLMSG = PeekW(@CBWPARAM+2)

  Select CBMSG
    Case #WM_COMMAND
      Select CBCTL
        Case #ID_RMC1         ; Message from the chart control
          Select CBCTLMSG
            Case #RMC_LBUTTONDOWN     ; Left mousebutton clicked
              nLButtonDown = #True  ; Set flag 
              *TINFO = CBLPARAM    ; lParam holds a pointer to a tRMC_INFO structure    
              If nChangeData        ; if in the first line chart
                If *TINFO\nGCol>0
                  ; Set the new data
                  If RMC_SetSeriesSingleData(#ID_RMC1,1,1,*TINFO\nVirtData1,*TINFO\nGCol) = #RMC_NO_ERROR
                    ; Refresh the trend line
                    ; Calc the trend And get the needed X/Y positions (nL,nT,nR,nB) For the line
                    RMC_CalcTrend(#ID_RMC1,1,1,@nFirst,@nLast,@nL,@nT,@nR,@nB)
                    ; Add a CustomLine to show the new trend:
                    RMC_CODash(#ID_RMC1,1,nL,nT,nR,nB,#RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,#ColorRed,#ColorGreen),0,2,0,#RMC_ANCHOR_ARROW_CLOSED)
                    ; Draw the "legend" for the trend line:
                    RMC_CODash(#ID_RMC1,2,470,11,500,11,#RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,#ColorRed,#ColorGreen),0,2)
                    RMC_COText(#ID_RMC1,3,"Trend",505,5)
                    ; Draw the chart with the new data and the trend line
                    RMC_Draw(#ID_RMC1)
                  EndIf
                EndIf    
              EndIf
              If *TINFO\nChartType = #RMC_MAGNIFIER_MODE ; if in magnification mode
                Show_Magnification(*TINFO)   ; show the magnification
              EndIf
              ; See RMC_LBUTTONUP, RMC_ZOOM_MODE:
              nOldX = *TINFO\nXPos
              nOldY = *TINFO\nYPos
            Case #RMC_SHIFTLBUTTONDOWN                            
              *TINFO = CBLPARAM    ; lParam holds a pointer to a tRMC_INFO structure    
              If *TINFO\nChartType = #RMC_MAGNIFIER_MODE ; if in magnification mode
                Show_Magnification(*TINFO)   ; show the magnification
              EndIf
            Case #RMC_SHIFTRBUTTONDOWN                            
              *TINFO = CBLPARAM    ; lParam holds a pointer to a tRMC_INFO structure    
              If *TINFO\nChartType = #RMC_MAGNIFIER_MODE ; If in magnification mode
                Show_Magnification(*TINFO)   ; show the magnification
              EndIf                                                           
            Case #RMC_CTRLLBUTTONDOWN     ; CtrlLeft mousebutton clicked
              *TINFO = CBLPARAM      ; lParam holds a pointer to a tRMC_INFO structure
              ShowInfo(*TINFO)       ; Show the content of this structure
            Case #RMC_MOUSEMOVE
              If nLButtonDown And nIsChart2
                *TINFO = CBLPARAM
                If *TINFO\nChartType = #RMC_MAGNIFIER_MODE ; if in magnification mode
                  Show_Magnification(*TINFO) ; show the magnification
                EndIf
              EndIf            
            Case #RMC_LBUTTONUP
              nLButtonDown = #False  ; Reset flag 
              If nIsChart2
                *TINFO = CBLPARAM
                If *TINFO\nChartType = #RMC_ZOOM_MODE ; If in zoom mode
                  Show_ZoomedArea(*TINFO) ; show the zoomed area
                EndIf
              EndIf            
          EndSelect                         
      EndSelect                
    Case #WM_VSCROLL ; the vertical scrollbar from "Scroll chart" (see Function Build_ScrollChart)
      ;not needed API-stuff (Replaced with native PB-Code)
      ;###################################################
      ;sih\cbSize = SizeOf(sih)
      ;sih\fMask = #SIF_ALL
      ;GetScrollInfo_(GadgetID(#ID_SCROLL), #SB_CTL, sih)
      ;notfound=1
      ;Select LOWRD(@CBWPARAM)
      ;  Case #SB_LINEDOWN
      ;    sih\nPos = MIN(sih\nPos + 1,(sih\nMax-sih\nPage)+1)
      ;  Case #SB_LINEUP 
      ;    sih\nPos = MAX(1,sih\nPos - 1)
      ;  Case #SB_PAGEUP                                                        
      ;    sih\nPos = MAX(1,sih\nPos - (sih\nPage-1))
      ;  Case #SB_PAGEDOWN                                                      
      ;    sih\nPos = MIN(sih\nPos + (sih\nPage-1),(sih\nMax-sih\nPage)+1)
      ;  Case #SB_THUMBTRACK    
      ;    sih\nPos = HIWRD(@CBWPARAM)
      ;  Case #SB_TOP
      ;    sih\nPos = 1
      ;  Case #SB_BOTTOM 
      ;    sih\nPos = (sih\nMax-sih\nPage)+1
      ;  Default
      ;    ;Result=#True
      ;    notfound=0
      ;EndSelect
      ;If notfound
      ;  SetScrollInfo_(GadgetID(#ID_SCROLL), #SB_CTL, sih, #True)
      ;  nFirst = sih\nPos
      ;  nLast = nFirst + 20
      ;  ; Set the new data range for the first series (Bars):
      ;  RMC_SetSeriesDataRange(#ID_RMC1,1,1,nFirst,nLast)
      ;  ; Set the new data range for the second series (Line):
      ;  RMC_SetSeriesDataRange(#ID_RMC1,1,2,nFirst,nLast)
      ;  ; Set the new range for the lables of the label axis
      ;  RMC_SetLAXLabelsRange(#ID_RMC1,1,nFirst,nLast)
      ;  RMC_Draw(#ID_RMC1) ; Show the chart with the new data
      ;EndIf
  EndSelect
  
  ProcedureReturn Result
EndProcedure

; *********************************** MiniDesigner *********************************************
Procedure ShowMDInfo()
  Protected sInfo.s
  
  sInfo="The important message of the 'MiniDesigner' is not,"+#CRLF$
  sInfo+"what can be done with it, but how is it done. Play with"+#CRLF$
  sInfo+"it and check CALLBACK FUNCTION MDCallback in the source"+#CRLF$
  sInfo+"to see, how it works."+#CRLF$
  sInfo+"You can see mouse support in action and how easy it is to change"+#CRLF$
  sInfo+"the properties of an existing chart. Maybe this gives you some"+#CRLF$
  sInfo+"ideas for your own work with RMChart."+#CRLF$+#CRLF$
  sInfo+" - Change the properties of the chart"+#CRLF$
  sInfo+" - Check/uncheck 'Show the cloned chart'"+#CRLF$
  sInfo+" - Resize/Maximize the dialog"+#CRLF$
  sInfo+" - Press the middle mouse button/ mouse wheel and move the upper chart"+#CRLF$
  sInfo+" - Click with ctrl+left mouse button onto different parts of the upper chart"+#CRLF$
  sInfo+" - Click and hold with left mouse button onto a bar and move up and down"+#CRLF$
  sInfo+" - Click with the right mouse button into the grid"+#CRLF$
  sInfo+" - Click with ctrl+right mouse button into the grid"+#CRLF$
  sInfo+" - Click with shift+right mouse button into the grid"+#CRLF$
  sInfo+" - Click with shift+left mouse button on the red bullet in the upper chart,"+#CRLF$
  sInfo+"   hold mouse button down and move the cursor." 
  
  MessageRequester("RMChart Demo",sInfo,#MB_OK|#MB_ICONINFORMATION)
EndProcedure


; Draws the upper and (if visible) the lower chart
Procedure DrawCharts() 
  Protected szTemp.s
  RMC_Draw(#ID_RMC2)             ; Draw the upper chart
  If nShowClone                  ; if the lower chart is vivible
    szTemp=Space(65536)
    RMC_WriteRMCFile(#ID_RMC2,szTemp) ; get the data string from the upper chart
    RMC_SetRMCFile(#ID_RMC3,szTemp)   ; Set the data string in the existent lower chart
    RMC_SetCaptionText(#ID_RMC3,1,"I'm the clone") ; change the caption from "I'm the original"
    RMC_Draw(#ID_RMC3)                ; Draw the lower chart  
  EndIf    
EndProcedure

; Callback function for the MiniDesigner, everything important happens here!
Procedure MDCallback(CBHNDL.l, CBMSG.l, CBWPARAM.l, CBLPARAM.l)
  Protected nError.l, nResult.l, hDC.l, x.l, y.l, nW.l, nH.l
  Protected szTemp.s;{2000}
  Protected *TINFO.RMC_INFO
  Protected tRect.RECT
  Protected Result.l
  Protected CBCTL.w,CBCTLMSG.w
  
  Static nLBDN.l, nMBDN.l, nShLBDn.l    ; for status of the Left and Middle mousebutton
  Static nC.l
  
  Result=#PB_ProcessPureBasicEvents
  
  CBCTL = PeekW(@CBWPARAM+0)
  CBCTLMSG = PeekW(@CBWPARAM+2)
  
  Select CBMSG
    Case #WM_CREATE
      nLBDN = 0 
    Case #WM_COMMAND
      Select CBCTL          ; select which control sends a message        
        Case #ID_RMC2              ; the upper chart sends a message
          Select CBCTLMSG   ; which message
            Case #RMC_CTRLLBUTTONDOWN     ; Ctrl-Left mousebutton clicked
              *TINFO = CBLPARAM      ; lParam holds a pointer to a tRMC_INFO structure
              ShowInfo(*TINFO)      ; Show the content of this structure                    
            Case #RMC_LBUTTONDOWN  ; left mousebutton pressed
              nLBDN = 1          ; set the flag for the first series (see #RMC_MOUSEMOVE)
            Case #RMC_LBUTTONUP    ; left mousebutton unpressed
              nLBDN = 0          ; remove the flag
              nShLBDn = 0
            Case #RMC_MBUTTONDOWN  ; Middle mousebutton pressed
              nMBDN = 1          ; set the flag for moving the chart (see #RMC_MOUSEMOVE)
            Case #RMC_MBUTTONUP    ; Middle mousebutton unpressed
              nMBDN = 0          ; remove the flag                          
            Case #RMC_RBUTTONDOWN  ; right mousebutton pressed
              *TINFO = CBLPARAM      ; lParam holds a pointer to a tRMC_INFO structure
              If *TINFO\nGCol>0
                ; Set the "virtual" data for the second series (line); nDataIndex == @TINFO.nGCol
                RMC_SetSeriesSingleData(#ID_RMC2,1,2,*TINFO\nVirtData2,*TINFO\nGCol)
                DrawCharts()
              EndIf
            Case #RMC_SHIFTLBUTTONDOWN
              *TINFO = CBLPARAM
              If *TINFO\nChartType = #RMC_CO_SYMBOL
                nShLBDn = #True ; Valid, if the red Bullet is clicked
              EndIf
            Case #RMC_SHIFTLBUTTONUP
              nShLBDn = 0                       
            Case #RMC_SHIFTRBUTTONDOWN
              *TINFO = CBLPARAM 
              If *TINFO\nGCol>0 ; if clicked into a grid column
                RMC_SetSeriesColor(#ID_RMC2,1,1,#ColorRed,*TINFO\nGCol) ; change the color for this bar
                DrawCharts()
              EndIf
            Case #RMC_CTRLRBUTTONDOWN
              *TINFO = CBLPARAM         
              If *TINFO\nGCol>0 ; if clicked into a grid column
                RMC_SetSeriesColor(#ID_RMC2,1,1,#ColorGold,*TINFO\nGCol) ; change the color for this bar
                DrawCharts()
              EndIf
            Case #RMC_MOUSEMOVE    ; moving the mouse over the chart
              *TINFO = CBLPARAM     ; lParam holds a pointer to a tRMC_INFO structure
              If nLBDN              ; if left mousebutton is pressed
                If *TINFO\nGCol>0 ; If the GridCol member of TINFO holds a valid value
                  ; Set the "virtual" data for the first series (bars); nDataIndex == GridColIndex
                  RMC_SetSeriesSingleData(#ID_RMC2,1,1,*TINFO\nVirtData1,*TINFO\nGCol)
                  DrawCharts()     ; Draw the upper and the lower chart
                EndIf    
              EndIf
              If nMBDN ; If Middle mousebutton is pressed
                RMC_SetCtrlPos(#ID_RMC2,*TINFO\nXMove,*TINFO\nYMove,1) ; Move the chart
              EndIf
              If nShLBDn ; If Shift+Left was pressed, move the red Bullet
                RMC_COSymbol(#ID_RMC2,1,*TINFO\nXPos,*TINFO\nYPos,#RMC_SYMBOL_BULLET,#ColorRed)
                DrawCharts()
              EndIf
          EndSelect
      EndSelect
  EndSelect
  
  ProcedureReturn Result
EndProcedure

; Create the chart initially
Procedure DoTheChart(hParent.l)
  Protected nRetVal.l
  Protected szTemp.s
  Protected tRect.RECT
  Dim aData.d(5)
  
  GetClientRect_(hParent,tRect)
  
  ;************** Create the chart ********************** 
  nRetVal = RMC_CreateChart(hParent,#ID_RMC2,300,10,tRect\right-320,tRect\bottom-80,#ColorCornflowerBlue,#RMC_CTRLSTYLEFLAT,#False,"","Tahoma")
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add Region 1 ***************************** 
  nRetVal = RMC_AddRegion(#ID_RMC2,5,5,-5,-5,"this is the footer") 
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add caption to region 1 ******************* 
  nRetVal = RMC_AddCaption(#ID_RMC2,1,"I'm the original",#ColorCoral,#ColorFloralWhite,12,#True) 
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add grid to region 1 ***************************** 
  nRetVal = RMC_AddGrid(#ID_RMC2,1,#ColorAzure,#True,0,0,0,0) 
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add data axis to region 1 ***************************** 
  nRetVal = RMC_AddDataAxis(#ID_RMC2,1,#RMC_DATAAXISLEFT,0,1000,11,9,#ColorCornsilk,#ColorBlack,#RMC_LINESTYLESOLID,0,"","")
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add second data axis to region 1 ***************************** 
  nRetVal = RMC_AddDataAxis(#ID_RMC2,1,#RMC_DATAAXISRIGHT,0,9.7,0,0,0,0,0,2,"%","")
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add label axis to region 1 ***************************** 
  szTemp = "January*February*March*April*May*June"
  nRetVal = RMC_AddLabelAxis(#ID_RMC2,1, szTemp,1,6,#RMC_LABELAXISBOTTOM,8,#ColorCornsilk,#RMC_TEXTCENTER,#ColorBlack,#RMC_LINESTYLESOLID,"")
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add Series 1 to region 1 ******************************* 
  ;****** Read data values ******
  aData(0) = 150 : aData(1) = 300 : aData(2) = 200 : aData(3) = 400 : aData(4) = 600 : aData(5) = 800
  nRetVal = RMC_AddBarSeries(#ID_RMC2,1,@aData(0), 6,#RMC_BARSINGLE,#RMC_BAR_FLAT_GRADIENT2,#False,#ColorGold,#False,1,#RMC_VLABEL_NONE,1,#RMC_HATCHBRUSH_OFF)
  If nRetVal<0:Goto IsError:EndIf
  ;************** Add Series 2 to region 1 *******************************
  ;****** Read data values ******
  aData(0) = 8.9 : aData(1) = 4.1 : aData(2) = 3.88 : aData(3) = 2.1 : aData(4) = 1.3 : aData(5) = 4.3
  nRetVal = RMC_AddLineSeries(#ID_RMC2,1, @aData(0), 6,0,0,#RMC_LINE,#RMC_LINE_CABLE,#RMC_LSTYLE_LINE,#False,#ColorGreen,#RMC_SYMBOL_BULLET,2,#RMC_VLABEL_DEFAULT,#RMC_HATCHBRUSH_OFF)
  If nRetVal<0:Goto IsError:EndIf
  RMC_COSymbol(#ID_RMC2,1,(tRect\right-320)/2,(tRect\bottom-160)*0.1,#RMC_SYMBOL_BULLET, #ColorRed) ;
  ; Draw the upper chart initially
  nRetVal = RMC_Draw(#ID_RMC2)
  If nRetVal<0:Goto IsError:EndIf
  
  szTemp = Space(65536) ; allocate enough space to hold the data
  RMC_WriteRMCFile(#ID_RMC2,szTemp)  ; Get the data string from the upper chart for cloning
  RMC_CreateChartFromFile(hParent,#ID_RMC3,300,315,0,szTemp) ; Create a new chart from the data string of the upper chart
  ; Don't Draw() the chart, because at this moment the appropriate checkbox in the dialog is Not checked
  
  ; Only for the User Interface: for matching the original color to the color objects
  aCurColors(1)  = #ColorCornflowerBlue    ;Control BGColor
  aCurColors(2)  = #ColorCoral             ;Caption BGColor
  aCurColors(3)  = #ColorFloralWhite       ;Caption TextColor
  aCurColors(4)  = #ColorAzure             ;Grid BGColor
  aCurColors(5)  = #ColorCornsilk          ;DataAxis TextColor
  aCurColors(6)  = #ColorBlack             ;DataAxis LineColor
  aCurColors(7)  = #ColorCornsilk          ;LabelAxis TextColor
  aCurColors(8)  = #ColorBlack             ;LabelAxis LineColor
  aCurColors(9)  = #ColorGold              ;Color of series 1
  aCurColors(10) = #ColorGreen             ;Color of series 2
  
  IsError:
EndProcedure

Procedure.l MiniDesigner(hParent.l)
  Protected hDlg.l
  Protected hDlgID.l
  Protected nDlgH.l, nDlgW.l, nResult.l, CBH.l
  Protected nCCount.l, i.l, nValue.l, sColor$
  Protected nX.l,nY.l,x.l,y.l
  Protected *TINFO.RMC_INFO
  Protected tRect.RECT
  Dim aData.d(5)
  
  nDlgW = 580
  nDlgH = 390
  
  KillTimer_(hParent,1) ; Kill the timer   
  
  If OpenWindow(#Window_MiniDesigner,0,0,800,540,"RMChart Demo - MiniDesigner",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_TitleBar|#PB_Window_SizeGadget,hParent)
    hDlg=WindowID(#Window_MiniDesigner)
    If 1;CreateGadgetList(WindowID(#Window_MiniDesigner))
      nX = 10 : nY = 10
      Frame3DGadget(#PB_Any, 5, 5, 240, 70, "Change the color")
      test=TextGadget(#PB_Any, 15, 25, 60, 15, "Object")
      CBH=GadgetHeight(test)+8
      TextGadget(#PB_Any, 15, 50, 60, 15, "Color")
      ComboBoxGadget(#ID_CB_COLOROBJ, 130, 20, 110, CBH)
      ComboBoxGadget(#ID_CB_COLOR, 130, 45, 110, CBH)
      nCCount=Val(ReadColors(-1))
      For i = 1 To nCCount
        sColor$=ReadColors(i)
        nValue=Hex2Dec(StringField(sColor$,2,"="))
        sColor$=RemoveString(StringField(sColor$,1,"="),"#Color")
        COMBOADDLINE(#ID_CB_COLOR,sColor$,nValue)
      Next    
      COMBOSETINDEXDATA(#ID_CB_COLOR,#ColorCornflowerBlue)
      COMBOADDLINE(#ID_CB_COLOROBJ,"Control BGColor",1)
      COMBOADDLINE(#ID_CB_COLOROBJ,"Caption BGColor",2)
      COMBOADDLINE(#ID_CB_COLOROBJ,"Caption TextColor",3)
      COMBOADDLINE(#ID_CB_COLOROBJ,"Grid BGColor",4)
      COMBOADDLINE(#ID_CB_COLOROBJ,"DataAxis TextColor",5)
      COMBOADDLINE(#ID_CB_COLOROBJ,"DataAxis LineColor",6)
      COMBOADDLINE(#ID_CB_COLOROBJ,"LabelAxis TextColor",7)
      COMBOADDLINE(#ID_CB_COLOROBJ,"LabelAxis LineColor",8)
      COMBOADDLINE(#ID_CB_COLOROBJ,"Color of series 1",9)
      COMBOADDLINE(#ID_CB_COLOROBJ,"Color of series 2",10)
      COMBOSETINDEXDATA(#ID_CB_COLOROBJ,1)
      
      nY = 63
      Frame3DGadget(#PB_Any, 5, 80, 240, 40, "Change chart's orientation")
      OptionGadget(#ID_OPT_H, 15, 100, 75, 15, "Horizontal")
      OptionGadget(#ID_OPT_V, 100, 100, 60, 15, "Vertical")
      SetGadgetState(#ID_OPT_V,1)
      
      nY = 91
      Frame3DGadget(#PB_Any, 5, 130, 240, 40, "Choose the period")
      OptionGadget(#ID_OPT_FH, 15, 150, 100, 15, "First half of year")
      OptionGadget(#ID_OPT_SH, 120, 150, 120, 15, "Second half of year")
      SetGadgetState(#ID_OPT_FH,1)
      
      nY = 119
      Frame3DGadget(#PB_Any, 5, 175, 240, 35, "Tooltips")
      CheckBoxGadget(#ID_CHK_TOOLTIPS, 15, 190, 225, 15, "Enable ToolTips for the datapoints")
      
      nY = 147
      Frame3DGadget(#PB_Any, 5, 215, 240, 85, "Series 1")
      TextGadget(#PB_Any, 15, 235, 35, 15, "Style")
      ComboBoxGadget(#ID_CB_S1STYLE, 130, 230, 110, CBH)
      COMBOADDLINE(#ID_CB_S1STYLE,"Flat",#RMC_BAR_FLAT)
      COMBOADDLINE(#ID_CB_S1STYLE,"Flat, gradient style 1",#RMC_BAR_FLAT_GRADIENT1)
      COMBOADDLINE(#ID_CB_S1STYLE,"Flat, gradient style 2",#RMC_BAR_FLAT_GRADIENT2)
      COMBOADDLINE(#ID_CB_S1STYLE,"Hover",#RMC_BAR_HOVER)
      COMBOADDLINE(#ID_CB_S1STYLE,"3D",#RMC_BAR_3D)
      COMBOADDLINE(#ID_CB_S1STYLE,"3D, gradient style",#RMC_BAR_3D_GRADIENT)
      COMBOADDLINE(#ID_CB_S1STYLE,"Column flat",#RMC_COLUMN_FLAT)
      COMBOADDLINE(#ID_CB_S1STYLE,"Column 3D",#RMC_COLUMN_3D)
      COMBOADDLINE(#ID_CB_S1STYLE,"Column 3D, gradient style",#RMC_COLUMN_3D_GRADIENT)
      COMBOSETINDEXDATA(#ID_CB_S1STYLE,#RMC_BAR_FLAT_GRADIENT2)
      CheckBoxGadget(#ID_CHK_LUCENT, 15, 250, 110, 15, "Transparency on")
      CheckBoxGadget(#ID_CHK_S1VLABEL, 15, 265, 110, 15, "Show value label")
      CheckBoxGadget(#ID_CHK_S1HIDE, 15, 280, 110, 15, "Hide series")
      
      nY = 210
      Frame3DGadget(#PB_Any, 5, 305, 240, 95, "Series 2")
      TextGadget(#PB_Any, 15, 325, 30, 15, "Style")
      ComboBoxGadget(#ID_CB_S2STYLE, 130, 320, 110, CBH)
      COMBOADDLINE(#ID_CB_S2STYLE,"Flat Solid",#RMC_LINE_FLAT)
      COMBOADDLINE(#ID_CB_S2STYLE,"Flat Dot",#RMC_LINE_FLAT_DOT)
      COMBOADDLINE(#ID_CB_S2STYLE,"Flat Dash",#RMC_LINE_FLAT_DASH)
      COMBOADDLINE(#ID_CB_S2STYLE,"Flat DashDot",#RMC_LINE_FLAT_DASHDOT)
      COMBOADDLINE(#ID_CB_S2STYLE,"Flat DashDotDot",#RMC_LINE_FLAT_DASHDOTDOT)
      COMBOADDLINE(#ID_CB_S2STYLE,"Cable",#RMC_LINE_CABLE)
      COMBOADDLINE(#ID_CB_S2STYLE,"Cable with shadow",#RMC_LINE_CABLE_SHADOW)
      COMBOADDLINE(#ID_CB_S2STYLE,"No line, only symbols",#RMC_LINE_SYMBOLONLY)
      COMBOADDLINE(#ID_CB_S2STYLE,"3D",#RMC_LINE_3D)
      COMBOADDLINE(#ID_CB_S2STYLE,"3D, gradient style",#RMC_LINE_3D_GRADIENT)
      COMBOSETINDEXDATA(#ID_CB_S2STYLE,#RMC_LINE_CABLE)
      TextGadget(#ID_LBL_SYMBOLS, 15, 350, 50, 15, "Symbols")
      ComboBoxGadget(#ID_CB_SYMBOLS, 130, 345, 110, CBH)
      COMBOADDLINE(#ID_CB_SYMBOLS,"No symbol",#RMC_SYMBOL_NONE)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Bullet",#RMC_SYMBOL_BULLET)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Point",#RMC_SYMBOL_POINT)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Diamond",#RMC_SYMBOL_DIAMOND)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Square",#RMC_SYMBOL_SQUARE)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Star",#RMC_SYMBOL_STAR)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Arrow down",#RMC_SYMBOL_ARROW_DOWN)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Arrow up",#RMC_SYMBOL_ARROW_UP)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Circle",#RMC_SYMBOL_CIRCLE)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Rectangle",#RMC_SYMBOL_RECTANGLE)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Cross",#RMC_SYMBOL_CROSS)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Bullet small",#RMC_SYMBOL_BULLET_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Point small",#RMC_SYMBOL_POINT_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Diamond small",#RMC_SYMBOL_DIAMOND_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Square small",#RMC_SYMBOL_SQUARE_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Star small",#RMC_SYMBOL_STAR_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Arrow down small",#RMC_SYMBOL_ARROW_DOWN_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Arrow up small",#RMC_SYMBOL_ARROW_UP_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Circle small",#RMC_SYMBOL_CIRCLE_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Rectangle small",#RMC_SYMBOL_RECTANGLE_SMALL)
      COMBOADDLINE(#ID_CB_SYMBOLS,"Cross small",#RMC_SYMBOL_CROSS_SMALL)
      COMBOSETINDEXDATA(#ID_CB_SYMBOLS,#RMC_SYMBOL_BULLET)
      
      CheckBoxGadget(#ID_CHK_S2VLABEL, 15, 365, 105, 15, "Show value label")
      SetGadgetState(#ID_CHK_S2VLABEL,1)
      CheckBoxGadget(#ID_CHK_S2HIDE, 15, 380, 70, 15, "Hide series")
      
      nY = 282
      Frame3DGadget(#PB_Any, 5, 405, 240, 35, "Show/Hide second chart")
      CheckBoxGadget(#ID_CHK_CLONE, 15, 420, 225, 15, "Show the cloned chart")
      
      nY = 312
      Frame3DGadget(#PB_Any, 5, 445, 240, 65, "Print/Save/Copy to Clipboard the upper chart")
      OptionGadget(#ID_OPT_JPG, 15, 460, 75, 20, "As Bitmap")
      OptionGadget(#ID_OPT_EMF, 95, 460, 80, 20, "As EMF")
      SetGadgetState(#ID_OPT_JPG,1)
      ButtonGadget(#ID_CMD_PRINT, 15, 485, 50, 20, "&Print")
      ButtonGadget(#ID_CMD_SAVE, 75, 485, 50, 20, "&Save")
      ButtonGadget(#ID_CMD_COPY, 130, 485, 50, 20, "&Copy")
      
      ButtonGadget(#ID_MD_CLOSE, 15, 515, 50, 20, "&Close")
      ButtonGadget(#ID_INFO, 75, 515, 50, 20, "&Info")
      
      DoTheChart(hDlg)
    EndIf
  EndIf
  
  SetWindowCallback(@MDCallback(),#Window_Minidesigner)
  
  Repeat
    Event=WaitWindowEvent()
    Select Event
      Case #PB_Event_SizeWindow
        x=WindowWidth(#Window_Minidesigner)
        y=WindowHeight(#Window_Minidesigner)
        ; set the size of the upper chart, dependend on status of flag 'nShowClone'
        RMC_SetCtrlSize(#ID_RMC2,x-320,y-80 - IIF(nShowClone,y/2-40,0),0,1)
        If nShowClone ; if the lower chart is visible
          ; set the lower chart size ...
          RMC_SetCtrlSize(#ID_RMC3,x-320,(y-40) - (y/2),0,1)
          ; ... and position
          RMC_SetCtrlPos(#ID_RMC3,300,(y/2))
        EndIf            
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ID_CB_COLOROBJ ; Color object combobox
            If EventType()=#PB_EventType_RightClick
              x = COMBOGETSELDATA(#ID_CB_COLOROBJ)  ; Index of the selected object
              COMBOSETINDEXDATA(#ID_CB_COLOR,aCurColors(x))
            EndIf
          Case #ID_CB_COLOR      ; Color combobox
            If EventType()=#PB_EventType_RightClick
              x = COMBOGETSELDATA(#ID_CB_COLOROBJ)  ; Index of the selected object
              y = COMBOGETSELDATA(#ID_CB_COLOR)     ; Index of selected color
              aCurColors(x) = y                            ; Match color to object
              Select x                                     ; select the object and set the
                Case 1  ; Control BGColor                ; color With the appropriate function 
                  RMC_SetCtrlBGColor(#ID_RMC2,y)
                Case 2  ; Caption BGColor
                  RMC_SetCaptionBGColor(#ID_RMC2,1,y)
                Case 3  ; Caption TextColor
                  RMC_SetCaptionTextColor(#ID_RMC2,1,y)
                Case 4  ; Grid Color
                  RMC_SetGridBGColor(#ID_RMC2,1,y)
                Case 5  ; DataAxis TextColor
                  RMC_SetDAXTextColor(#ID_RMC2,1,y)
                Case 6  ; DataAxis LineColor
                  RMC_SetDAXLineColor(#ID_RMC2,1,y)
                Case 7  ; LabelAxis TextColor
                  RMC_SetLAXTextColor(#ID_RMC2,1,y)
                Case 8  ; LabelAxis LineColor
                  RMC_SetLAXLineColor(#ID_RMC2,1,y)
                Case 9  ; Color of series 1
                  RMC_SetSeriesColor(#ID_RMC2,1,1,y)
                Case 10  ; Color of series 2
                  RMC_SetSeriesColor(#ID_RMC2,1,2,y)
              EndSelect
              DrawCharts()
            EndIf                
          Case #ID_OPT_H,#ID_OPT_V            ; Horizontal or Vertical
            If EventType()=#PB_EventType_LeftClick
              x = OptGet(#ID_OPT_H,#ID_OPT_V) 
              If x = #ID_OPT_H                       ; Horizontal
                RMC_SetDAXAlignment(#ID_RMC2,1,#RMC_DATAAXISBOTTOM)   ; first dataaxis bottom
                ; alignment of second data axis and label axis gets adjusted automatically
                RMC_SetSeriesVertical(#ID_RMC2,1,1,#False)            ; series 1 horizontal
                RMC_SetSeriesVertical(#ID_RMC2,1,2,#False)            ; series 2 horizontal
              Else                                   ; Vertical 
                RMC_SetDAXAlignment(#ID_RMC2,1,#RMC_DATAAXISLEFT)     ; first dataaxis left
                ; alignment of second data axis and label axis gets adjusted automatically
                RMC_SetSeriesVertical(#ID_RMC2,1,1,#True)             ; series 1 vertical 
                RMC_SetSeriesVertical(#ID_RMC2,1,2,#True)             ; series 2 vertical
              EndIf    
              DrawCharts()
            EndIf
          Case #ID_OPT_FH,#ID_OPT_SH        ; First half or second half
            If EventType()=#PB_EventType_LeftClick
              x = OptGet(#ID_OPT_FH,#ID_OPT_SH)
              If x = #ID_OPT_FH                        ; first half of the year
                aData(0) = 150 : aData(1) = 300 : aData(2) = 200 : aData(3) = 400 : aData(4) = 600 : aData(5) = 800 
                ; Set new data for the first series
                RMC_SetSeriesData(#ID_RMC2,1,1,@aData(0),6)
                aData(0) = 8.9 : aData(1) = 4.1 : aData(2) = 3.88 : aData(3) = 2.1 : aData(4) = 1.3 : aData(5) = 4.3 
                ; Set new data for the second series
                RMC_SetSeriesData(#ID_RMC2,1,2,@aData(0),6)
                ; Set new labels
                RMC_SetLAXLabels(#ID_RMC2,1,"January*February*March*April*May*June")
              Else
                aData(0) = 700 : aData(1) = 450 : aData(2) = 380 : aData(3) = 520 : aData(4) = 610 : aData(5) = 420 
                ; Set new data for the first series
                RMC_SetSeriesData(#ID_RMC2,1,1,@aData(0),6)
                aData(0) = 1.9 : aData(1) = 3.8 : aData(2) = 5.2 : aData(3) = 7.4 : aData(4) = 4.5 : aData(5) = 2.3
                ; Set new data for the second series
                RMC_SetSeriesData(#ID_RMC2,1,2,@aData(0),6)
                ; Set new labels
                RMC_SetLAXLabels(#ID_RMC2,1,"July*August*September*October*November*December")
              EndIf
              DrawCharts()
            EndIf
          Case #ID_CB_S1STYLE,#ID_CB_S2STYLE ; Style for series 1 and 2
            If EventType()=#PB_EventType_RightClick ;CBCTLMSG = #CBN_SELCHANGE
              x = COMBOGETSELDATA(EventGadget())  ; Get the index of the selected object
              If EventGadget() = #ID_CB_S1STYLE
                RMC_SetSeriesStyle(#ID_RMC2,1,1,x)  ; Set style for series 1
              Else
                RMC_SetSeriesStyle(#ID_RMC2,1,2,x)  ; Set style for series 2
              EndIf
              DrawCharts()
            EndIf  
          Case #ID_CHK_LUCENT ; Transparency on/off for series 1
            RMC_SetSeriesLucent(#ID_RMC2,1,1,CheckGet(#ID_CHK_LUCENT))
            DrawCharts()
          Case #ID_CHK_S1VLABEL ; Valuelabel on/off for series 1
            RMC_SetSeriesValuelabel(#ID_RMC2,1,1,CheckGet(#ID_CHK_S1VLABEL))
            DrawCharts()
          Case #ID_CHK_S2VLABEL ; Valuelabel on/off for series 2
            RMC_SetSeriesValuelabel(#ID_RMC2,1,2,CheckGet(#ID_CHK_S2VLABEL))
            DrawCharts()
          Case #ID_CHK_S1HIDE ; Hide/show series 1
            RMC_SetSeriesHide(#ID_RMC2,1,1,CheckGet(#ID_CHK_S1HIDE))
            DrawCharts()
          Case #ID_CHK_S2HIDE ; Hide/show series 2
            RMC_SetSeriesHide(#ID_RMC2,1,2,CheckGet(#ID_CHK_S2HIDE))
            DrawCharts()
          Case #ID_CHK_TOOLTIPS ; Tooltips on/off
            x=IIF(CheckGet(#ID_CHK_TOOLTIPS),50,0)
            RMC_SetToolTipWidth(#ID_RMC2,x)
            If nShowClone ; if the lower chart is vivible
              RMC_SetToolTipWidth(#ID_RMC3,x)
            EndIf    
          Case #ID_CB_SYMBOLS ; Symbols for series 2
            If EventType() = #PB_EventType_RightClick
              RMC_SetSeriesSymbol(#ID_RMC2,1,2,COMBOGETSELDATA(EventGadget()))
              DrawCharts()
            EndIf    
          Case #ID_CHK_CLONE     ; Show or hide the lower chart
            nShowClone = CheckGet(#ID_CHK_CLONE)  ; Get the status
            tRect\right=WindowWidth(#Window_MiniDesigner)
            tRect\bottom=WindowHeight(#Window_MiniDesigner)
            ; set the size of the upper chart, dependend on status of flag 'nShowClone'    
            RMC_SetCtrlSize(#ID_RMC2,tRect\right-320,tRect\bottom-80 - IIF(nShowClone,tRect\bottom/2-40,0),0,1)
            If nShowClone         ; if the lower chart is visible
              ; set the lower chart size ...
              RMC_SetCtrlSize(#ID_RMC3,tRect\right-320,(tRect\bottom-40) - (tRect\bottom/2),0,1)
              DrawCharts()  ; Draw both charts
              ; Make the lower chart visible
              RMC_SetCtrlPos(#ID_RMC3,300,(tRect\bottom/2))
            Else                  ; if the lower chart is not visible        
              RMC_SetCtrlPos(#ID_RMC3,-2000,-2000)  ; make it invisible (shift it's position out of the Window)
            EndIf
          Case #ID_CMD_PRINT
            x = OptGet(#ID_OPT_JPG,#ID_OPT_EMF)
            If x=#ID_OPT_JPG
              RMC_Draw2Printer(#ID_RMC2,0,25,25,150,110,#RMC_BMP)
            Else
              RMC_Draw2Printer(#ID_RMC2,0,25,25,150,110,#RMC_EMF)
            EndIf
          Case #ID_CMD_SAVE
            x = OptGet(#ID_OPT_JPG,#ID_OPT_EMF)
            If x=#ID_OPT_JPG
              RMC_Draw2File(#ID_RMC2,"MiniDesigner.jpg")
            Else
              RMC_Draw2File(#ID_RMC2,"MiniDesigner.emf")
            EndIf
          Case #ID_CMD_COPY
            x = OptGet(#ID_OPT_JPG,#ID_OPT_EMF)                    
            If x=#ID_OPT_JPG
              RMC_Draw2Clipboard(#ID_RMC2,#RMC_BMP)
            Else
              RMC_Draw2Clipboard(#ID_RMC2,#RMC_EMF)
            EndIf
          Case #ID_INFO
            ShowMDInfo()
          Case #ID_MD_CLOSE
            Break
        EndSelect
    EndSelect
  Until Event=#PB_Event_CloseWindow
  
  CloseWindow(#Window_MiniDesigner)
EndProcedure

; ******** Helper functions for the MiniDesigner ********************
Procedure.s ReadColors(nIndex.l) ; Reads the colors from table (nIndex=-1 returns the amount of colors)
  Protected Datacount.l, isFound.l, sName.s
  
  If nIndex = -1              ; Colorcount                       
  	Restore Colors1
  	Repeat
  	  Read.s sName
  	  If sName<>"---End---"
  	    Datacount+1
  	  EndIf
  	Until sName="---End---"
  	ProcedureReturn Str(Datacount)
  ElseIf nIndex>0             ; Name and Value
  	Restore Colors1
  	Repeat
  	  Read.s sName
  	  Datacount+1
  	  If nIndex=Datacount
  	    isFound=#True
  	    Break
  	  EndIf
  	Until sName="---End---"
  	If isFound
  	  ProcedureReturn sName
  	EndIf
  EndIf	
EndProcedure

Procedure.l COMBOADDLINE(nCtrlID.l,sText.s,nData.l=0)
  Protected nIndex.l
  
  AddGadgetItem(nCtrlID,-1,sText)
  nIndex=CountGadgetItems(nCtrlID)-1
  SetGadgetItemData(nCtrlID,nIndex,nData)
  
  ProcedureReturn nIndex
EndProcedure

Procedure COMBOSETINDEXDATA(nCtrlID.l,nData.l)
  Protected i.l,nCount.l
  
  nCount=CountGadgetItems(nCtrlID)
  For i = 0 To nCount-1
    If nData = GetGadgetItemData(nCtrlID,i)
      SetGadgetState(nCtrlID,i)
      ProcedureReturn
    EndIf
  Next
  SetGadgetState(nCtrlID,-1)
EndProcedure

Procedure.l COMBOGETSELINDEX(nCtrlID.l)
  ProcedureReturn GetGadgetState(nCtrlID)
EndProcedure

Procedure.l COMBOGETSELDATA(nCtrlID.l)
  ProcedureReturn GetGadgetItemData(nCtrlID,GetGadgetState(nCtrlID))
EndProcedure

Procedure.l CheckGet(nCtrlID.l)
  ProcedureReturn GetGadgetState(nCtrlID)
EndProcedure

Procedure CheckSet(nCtrlID.l, nState.l)
  SetGadgetState(nCtrlID,nState)
EndProcedure

Procedure.l OptGet(nLower.l, nUpper.l)
  Protected i.l
  Protected nOpt.l
  For i=nLower To nUpper
    nOpt=GetGadgetState(i)
    If nOpt=1
      nOpt = i
      Break
    EndIf
  Next
  ProcedureReturn nOpt
EndProcedure

DataSection
  Colors1:
  Data.s "#ColorAliceBlue=$FFF0F8FF","#ColorAntiqueWhite=$FFFAEBD7","#ColorAquamarine=$FF7FFFD4","#ColorArmyGreen=$FF669966"
  Data.s "#ColorAutumnOrange=$FFFF6633","#ColorAvocadoGreen=$FF669933","#ColorAzure=$FFF0FFFF","#ColorBabyBlue=$FF6699FF"
  Data.s "#ColorBananaYellow=$FFCCCC33","#ColorBeige=$FFF5F5DC","#ColorBisque=$FFFFE4C4","#ColorBlack=$FF000000"
  Data.s "#ColorBlanchedAlmond=$FFFFEBCD","#ColorBlue=$FF0000FF","#ColorBlueViolet=$FF8A2BE2","#ColorBrown=$FFA52A2A"
  Data.s "#ColorBurlyWood=$FFDEB887","#ColorCadetBlue=$FF5F9EA0","#ColorChalk=$FFFFFF99","#ColorChartreuse=$FF7FFF00"
  Data.s "#ColorChocolate=$FFD2691E","#ColorCoral=$FFFF7F50","#ColorCornflowerBlue=$FF6495ED","#ColorCornsilk=$FFFFF8DC"
  Data.s "#ColorCrimson=$FFDC143C","#ColorCyan=$FF00FFFF","#ColorDarkBlue=$FF00008B","#ColorDarkBrown=$FF663333"
  Data.s "#ColorDarkCrimson=$FF993366","#ColorDarkCyan=$FF008B8B","#ColorDarkGold=$FFCC9933","#ColorDarkGoldenrod=$FFB8860B"
  Data.s "#ColorDarkGray=$FFA9A9A9","#ColorDarkGreen=$FF006400","#ColorDarkKhaki=$FFBDB76B","#ColorDarkMagenta=$FF8B008B"
  Data.s "#ColorDarkOliveGreen=$FF556B2F","#ColorDarkOrange=$FFFF8C00","#ColorDarkOrchid=$FF9932CC","#ColorDarkRed=$FF8B0000"
  Data.s "#ColorDarkSalmon=$FFE9967A","#ColorDarkSeaGreen=$FF8FBC8B","#ColorDarkSlateBlue=$FF483D8B","#ColorDarkSlateGray=$FF2F4F4F"
  Data.s "#ColorDarkTurquoise=$FF00CED1","#ColorDarkViolet=$FF9400D3","#ColorDeepAzure=$FF6633FF","#ColorDeepPink=$FFFF1493"
  Data.s "#ColorDeepPurple=$FF330066","#ColorDeepRiver=$FF6600CC","#ColorDeepRose=$FFCC3399","#ColorDeepSkyBlue=$FF00BFFF"
  Data.s "#ColorDefault=0","#ColorDeepYellow=$FFFFCC00","#ColorDesertBlue=$FF336699","#ColorDimGray=$FF696969","#ColorDodgerBlue=$FF1E90FF"
  Data.s "#ColorDullGreen=$FF99CC66","#ColorEasterPurple=$FFCC99FF","#ColorFadeGreen=$FF99CC99","#ColorFirebrick=$FFB22222"
  Data.s "#ColorFloralWhite=$FFFFFAF0","#ColorForestGreen=$FF228B22","#ColorGainsboro=$FFDCDCDC","#ColorGhostGreen=$FFCCFFCC"
  Data.s "#ColorGhostWhite=$FFF8F8FF","#ColorGold=$FFFFD700","#ColorGoldenrod=$FFDAA520","#ColorGrape=$FF663399"
  Data.s "#ColorGrassGreen=$FF009933","#ColorGray=$FF808080","#ColorGreen=$FF008000","#ColorGreenYellow=$FFADFF2F"
  Data.s "#ColorHoneydew=$FFF0FFF0","#ColorHotPink=$FFFF69B4","#ColorIndianRed=$FFCD5C5C","#ColorIndigo=$FF4B0082"
  Data.s "#ColorIvory=$FFFFFFF0","#ColorKentuckyGreen=$FF339966","#ColorKhaki=$FFF0E68C","#ColorLavender=$FFE6E6FA"
  Data.s "#ColorLavenderBlush=$FFFFF0F5","#ColorLawnGreen=$FF7CFC00","#ColorLemonChiffon=$FFFFFACD","#ColorLightBlue=$FFADD8E6"
  Data.s "#ColorLightCoral=$FFF08080","#ColorLightCyan=$FFE0FFFF","#ColorLightGoldenrod=$FFEEDD82","#ColorLightGoldenrodYellow=$FFFAFAD2"
  Data.s "#ColorLightGray=$FFD3D3D3","#ColorLightGreen=$FF90EE90","#ColorLightOrange=$FFFF9933","#ColorLightPink=$FFFFB6C1"
  Data.s "#ColorLightSalmon=$FFFFA07A","#ColorLightSeaGreen=$FF20B2AA","#ColorLightSkyBlue=$FF87CEFA","#ColorLightSlateGray=$FF778899"
  Data.s "#ColorLightSteelBlue=$FFB0C4DE","#ColorLightViolet=$FFFF99FF","#ColorLightYellow=$FFFFFFE0","#ColorLime=$FF00FF00"
  Data.s "#ColorLimeGreen=$FF32CD32","#ColorLinen=$FFFAF0E6","#ColorMagenta=$FFFF00FF","#ColorMaroon=$FF800000"
  Data.s "#ColorMartianGreen=$FF99CC33","#ColorMediumAquamarine=$FF66CDAA","#ColorMediumBlue=$FF0000CD","#ColorMediumOrchid=$FFBA55D3"
  Data.s "#ColorMediumPurple=$FF9370DB","#ColorMediumSeaGreen=$FF3CB371","#ColorMediumSlateBlue=$FF7B68EE","#ColorMediumSpringGreen=$FF00FA9A"
  Data.s "#ColorMediumTurquoise=$FF48D1CC","#ColorMediumVioletRed=$FFC71585","#ColorMidnightBlue=$FF191970"
  Data.s "#ColorMintCream=$FFF5FFFA","#ColorMistyRose=$FFFFE4E1","#ColorMoccasin=$FFFFE4B5","#ColorMoonGreen=$FFCCFF66"
  Data.s "#ColorMossGreen=$FF336666","#ColorNavajoWhite=$FFFFDEAD","#ColorNavy=$FF000080","#ColorOceanGreen=$FF669999"
  Data.s "#ColorOldLace=$FFFDF5E6","#ColorOlive=$FF808000","#ColorOliveDrab=$FF6B8E23","#ColorOrange=$FFFFA500"
  Data.s "#ColorOrangeRed=$FFFF4500","#ColorOrchid=$FFDA70D6","#ColorPaleGoldenrod=$FFEEE8AA","#ColorPaleGreen=$FF98FB98"
  Data.s "#ColorPaleTurquoise=$FFAFEEEE","#ColorPaleVioletRed=$FFDB7093","#ColorPaleYellow=$FFFFFFCC","#ColorPapayaWhip=$FFFFEFD5"
  Data.s "#ColorPeachPuff=$FFFFDAB9","#ColorPeru=$FFCD853F","#ColorPink=$FFFFC0CB","#ColorPlum=$FFDDA0DD","#ColorPowderBlue=$FFB0E0E6"
  Data.s "#ColorPurple=$FF800080","#ColorRed=$FFFF0000","#ColorRosyBrown=$FFBC8F8F","#ColorRoyalBlue=$FF4169E1"
  Data.s "#ColorSaddleBrown=$FF8B4513","#ColorSalmon=$FFFA8072","#ColorSand=$FFFFCC99","#ColorSandyBrown=$FFF4A460"
  Data.s "#ColorSeaGreen=$FF2E8B57","#ColorSeaShell=$FFFFF5EE","#ColorSienna=$FFA0522D","#ColorSilver=$FFC0C0C0"
  Data.s "#ColorSkyBlue=$FF87CEEB","#ColorSlateBlue=$FF6A5ACD","#ColorSlateGray=$FF708090","#ColorSnow=$FFFFFAFA"
  Data.s "#ColorSpringGreen=$FF00FF7F","#ColorSteelBlue=$FF4682B4","#ColorTan=$FFD2B48C","#ColorTeal=$FF008080"
  Data.s "#ColorThistle=$FFD8BFD8","#ColorTomato=$FFFF6347","#ColorTransparent=$FFFFFFFE","#ColorTropicalPink=$FFFF6666","#ColorTurquoise=$FF40E0D0"
  Data.s "#ColorViolet=$FFEE82EE","#ColorVioletRed=$FFD02090","#ColorWalnut=$FF663300","#ColorWheat=$FFF5DEB3"
  Data.s "#ColorWhite=$FFFFFFFF","#ColorWhiteSmoke=$FFF5F5F5","#ColorYellow=$FFFFFF00","#ColorYellowGreen=$FF9ACD32"
  Data.s "---End---"
EndDataSection

nDlgW=820
nDlgH=620
If OpenWindow(#Window_Main,0,0,nDlgW,nDlgH,"RMChart Demo",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_TitleBar|#PB_Window_SizeGadget)
  If 1;CreateGadgetList(WindowID(#Window_Main))
    ButtonGadget(#ID_EXPORT,(nDlgW/2) - 115,nDlgH-40,80,15,"&Save bitmap")
    ButtonGadget(#ID_PRINT,(nDlgW/2) - 25,nDlgH-40,80,15,"&Print")
    ButtonGadget(#ID_CLOSE,(nDlgW/2) + 65,nDlgH-40,80,15,"&End")
    ScrollBarGadget(#ID_SCROLL,nDlgW-30,10,24,500,0,0,0,#PB_ScrollBar_Vertical)
    HideGadget(#ID_SCROLL,1)
    
    If CreateMenu(#Menu_Main,WindowID(#Window_Main))
      MenuTitle("&Grid-based")
        MenuItem(#ID_GB1,"Single bars")
        MenuItem(#ID_GB2,"Grouped bars")
        MenuItem(#ID_GB3,"Stacked bars")
        MenuItem(#ID_GB10,"Floating bars")
        MenuItem(#ID_GB8,"Bars with diff. colors and BgImage")
        MenuBar()
        MenuItem(#ID_GB4,"Line with a trend line")
        MenuItem(#ID_GB5,"Indexed lines")
        MenuItem(#ID_GB7,"Lines with missing data")
        MenuBar()
        MenuItem(#ID_GB6,"Bars and line")
      MenuTitle("&Non-grid based")
        MenuItem(#ID_NGB2,"Donut with image")
        MenuItem(#ID_NGB1,"Pie")
      MenuTitle("&XY scatter")
        MenuItem(#ID_XY2,"Simple XY")
        MenuItem(#ID_XY1,"XY with 2 series")
      MenuTitle("&Miscellaneous")
        MenuItem(#ID_MSC1,"Scroll chart")
        MenuItem(#ID_MSC4,"Timer chart")
        MenuItem(#ID_MSC7,"Transparent control")
        MenuItem(#ID_MSC5,"Draw chart from data string")
        MenuItem(#ID_MSC2,"Draw chart from file")
        MenuItem(#ID_MSC3,"Save chart without painting")
        MenuBar()
        MenuItem(#ID_MSC8,"Zoom internal")
        MenuItem(#ID_MSC10,"Zoom external")
        MenuItem(#ID_MSC9,"Magnifier")
        MenuBar()
        MenuItem(#ID_MSC6,"MiniDesigner")
    EndIf
  EndIf
Else
  End
EndIf

hCursorWait = LoadCursor_(0,#IDC_WAIT)

DisableGadget(#ID_PRINT,0)
DisableGadget(#ID_EXPORT,0)

SetWindowCallback(@DlgCallback(),#Window_Main)

Repeat
  Event=WaitWindowEvent()
  Select Event
    Case #PB_Event_Menu
      Select EventMenu()
        Case #ID_GB1
          Show_Bars(WindowID(#Window_Main))
        Case #ID_GB2
          Show_GroupedBars(WindowID(#Window_Main))
        Case #ID_GB3
          Show_StackedBars(WindowID(#Window_Main))
        Case #ID_GB10
          Show_FloatingBars(WindowID(#Window_Main))
        Case #ID_GB4
          Show_Line(WindowID(#Window_Main))
        Case #ID_GB5
          Show_3Lines(WindowID(#Window_Main))
        Case #ID_GB6
          Show_BarsAndLine(WindowID(#Window_Main))
        Case #ID_GB7
          Show_MissingData(WindowID(#Window_Main))
        Case #ID_GB8
          Show_BarsImage(WindowID(#Window_Main))
        Case #ID_NGB2
          Show_Donut(WindowID(#Window_Main))
        Case #ID_NGB1
          Show_Pie(WindowID(#Window_Main)) 
        Case #ID_XY1
          Show_XY2Series(WindowID(#Window_Main))
        Case #ID_XY2
          Show_SimpleXY(WindowID(#Window_Main))
        Case #ID_MSC1
          ; Call the Sub which builds the chart, but does not show it
          Build_ScrollChart(WindowID(#Window_Main))  
          ; Set the initial data range
          RMC_SetSeriesDataRange(#ID_RMC1,1,1,1,21)
          RMC_SetSeriesDataRange(#ID_RMC1,1,2,1,21)
          ; Set the initial range for the labels
          RMC_SetLAXLabelsRange(#ID_RMC1,1,1,21)
          RMC_Draw(#ID_RMC1)  ; Draw the chart for the first time
        Case #ID_MSC2
          Show_File(WindowID(#Window_Main)) 
        Case #ID_MSC3
          Chart2Bmp(WindowID(#Window_Main)) 
        Case #ID_MSC4 ; TimerChart example
          TimerChart(WindowID(#Window_Main)) 
        Case #ID_MSC5
          Show_DataString(WindowID(#Window_Main)) 
        Case #ID_MSC6
          MiniDesigner(WindowID(#Window_Main))
        Case #ID_MSC7
          Show_Transparent(WindowID(#Window_Main))
        Case #ID_MSC8
          Show_ZoomInternal(WindowID(#Window_Main)) 
        Case #ID_MSC9
          Show_Magnifier(WindowID(#Window_Main))
        Case #ID_MSC10
          Show_ZoomExternal(WindowID(#Window_Main))
      EndSelect
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #ID_SCROLL
          nFirst=GetGadgetState(#ID_SCROLL)
          nLast = nFirst + 20
          ; Set the new data range for the first series (Bars):
          RMC_SetSeriesDataRange(#ID_RMC1,1,1,nFirst,nLast)
          ; Set the new data range for the second series (Line):
          RMC_SetSeriesDataRange(#ID_RMC1,1,2,nFirst,nLast)
          ; Set the new range for the lables of the label axis
          RMC_SetLAXLabelsRange(#ID_RMC1,1,nFirst,nLast)
          RMC_Draw(#ID_RMC1) ; Show the chart with the new data
        Case #ID_CLOSE
          Break
        Case #ID_EXPORT
          ExportTheChart(WindowID(#Window_Main), #ID_RMC1)
        Case #ID_PRINT
          Result=PrintRequester()
          If Result
            hDC=StartDrawing(PrinterOutput())
              UpdateWindow_(WindowID(#Window_Main))
              RMC_Draw2Printer(#ID_RMC1,hDC)
            StopDrawing()
          EndIf
      EndSelect
  EndSelect
Until Event=#PB_Event_CloseWindow

CloseWindow(#Window_Main)
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 2430
; FirstLine = 2428
; Folding = ---------